The Python package installer https://pip.pypa.io/
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 

2625 lines
126 KiB

  1. .. note
  2. You should *NOT* be adding new change log entries to this file, this
  3. file is managed by towncrier. You *may* edit previous change logs to
  4. fix problems like typo corrections or such.
  5. To add a new change log entry, please see
  6. https://pip.pypa.io/en/latest/development/contributing/#news-entries
  7. .. towncrier release notes start
  8. 20.2.4 (2020-10-16)
  9. ===================
  10. Deprecations and Removals
  11. -------------------------
  12. - Document that certain removals can be fast tracked. (`#8417 <https://github.com/pypa/pip/issues/8417>`_)
  13. - Document that Python versions are generally supported until PyPI usage falls below 5%. (`#8927 <https://github.com/pypa/pip/issues/8927>`_)
  14. Features
  15. --------
  16. - New resolver: Avoid accessing indexes when the installed candidate is preferred
  17. and considered good enough. (`#8023 <https://github.com/pypa/pip/issues/8023>`_)
  18. - Improve error message friendliness when an environment has packages with
  19. corrupted metadata. (`#8676 <https://github.com/pypa/pip/issues/8676>`_)
  20. - Cache package listings on index packages so they are guarenteed to stay stable
  21. during a pip command session. This also improves performance when a index page
  22. is accessed multiple times during the command session. (`#8905 <https://github.com/pypa/pip/issues/8905>`_)
  23. - New resolver: Tweak resolution logic to improve user experience when
  24. user-supplied requirements conflict. (`#8924 <https://github.com/pypa/pip/issues/8924>`_)
  25. Bug Fixes
  26. ---------
  27. - New resolver: Correctly respect ``Requires-Python`` metadata to reject
  28. incompatible packages in ``--no-deps`` mode. (`#8758 <https://github.com/pypa/pip/issues/8758>`_)
  29. - New resolver: Pick up hash declarations in constraints files and use them to
  30. filter available distributions. (`#8792 <https://github.com/pypa/pip/issues/8792>`_)
  31. - New resolver: If a package appears multiple times in user specification with
  32. different ``--hash`` options, only hashes that present in all specifications
  33. should be allowed. (`#8839 <https://github.com/pypa/pip/issues/8839>`_)
  34. Improved Documentation
  35. ----------------------
  36. - Add ux documentation (`#8807 <https://github.com/pypa/pip/issues/8807>`_)
  37. 20.2.3 (2020-09-08)
  38. ===================
  39. Deprecations and Removals
  40. -------------------------
  41. - Deprecate support for Python 3.5 (`#8181 <https://github.com/pypa/pip/issues/8181>`_)
  42. Features
  43. --------
  44. - Make the ``setup.py install`` deprecation warning less noisy. We warn only
  45. when ``setup.py install`` succeeded and ``setup.py bdist_wheel`` failed, as
  46. situations where both fails are most probably irrelevant to this deprecation. (`#8752 <https://github.com/pypa/pip/issues/8752>`_)
  47. 20.2.2 (2020-08-11)
  48. ===================
  49. Bug Fixes
  50. ---------
  51. - Only attempt to use the keyring once and if it fails, don't try again.
  52. This prevents spamming users with several keyring unlock prompts when they
  53. cannot unlock or don't want to do so. (`#8090 <https://github.com/pypa/pip/issues/8090>`_)
  54. - Fix regression that distributions in system site-packages are not correctly
  55. found when a virtual environment is configured with ``system-site-packages``
  56. on. (`#8695 <https://github.com/pypa/pip/issues/8695>`_)
  57. - Disable caching for range requests, which causes corrupted wheels
  58. when pip tries to obtain metadata using the feature ``fast-deps``. (`#8701 <https://github.com/pypa/pip/issues/8701>`_, `#8716 <https://github.com/pypa/pip/issues/8716>`_)
  59. - Always use UTF-8 to read ``pyvenv.cfg`` to match the built-in ``venv``. (`#8717 <https://github.com/pypa/pip/issues/8717>`_)
  60. - 2020 Resolver: Correctly handle marker evaluation in constraints and exclude
  61. them if their markers do not match the current environment. (`#8724 <https://github.com/pypa/pip/issues/8724>`_)
  62. 20.2.1 (2020-08-04)
  63. ===================
  64. Features
  65. --------
  66. - Ignore require-virtualenv in ``pip list`` (`#8603 <https://github.com/pypa/pip/issues/8603>`_)
  67. Bug Fixes
  68. ---------
  69. - Correctly find already-installed distributions with dot (``.``) in the name
  70. and uninstall them when needed. (`#8645 <https://github.com/pypa/pip/issues/8645>`_)
  71. - Trace a better error message on installation failure due to invalid ``.data``
  72. files in wheels. (`#8654 <https://github.com/pypa/pip/issues/8654>`_)
  73. - Fix SVN version detection for alternative SVN distributions. (`#8665 <https://github.com/pypa/pip/issues/8665>`_)
  74. - New resolver: Correctly include the base package when specified with extras
  75. in ``--no-deps`` mode. (`#8677 <https://github.com/pypa/pip/issues/8677>`_)
  76. - Use UTF-8 to handle ZIP archive entries on Python 2 according to PEP 427, so
  77. non-ASCII paths can be resolved as expected. (`#8684 <https://github.com/pypa/pip/issues/8684>`_)
  78. Improved Documentation
  79. ----------------------
  80. - Add details on old resolver deprecation and removal to migration documentation. (`#8371 <https://github.com/pypa/pip/issues/8371>`_)
  81. - Fix feature flag name in docs. (`#8660 <https://github.com/pypa/pip/issues/8660>`_)
  82. 20.2 (2020-07-29)
  83. =================
  84. Deprecations and Removals
  85. -------------------------
  86. - Deprecate setup.py-based builds that do not generate an ``.egg-info`` directory. (`#6998 <https://github.com/pypa/pip/issues/6998>`_, `#8617 <https://github.com/pypa/pip/issues/8617>`_)
  87. - Disallow passing install-location-related arguments in ``--install-options``. (`#7309 <https://github.com/pypa/pip/issues/7309>`_)
  88. - Add deprecation warning for invalid requirements format "base>=1.0[extra]" (`#8288 <https://github.com/pypa/pip/issues/8288>`_)
  89. - Deprecate legacy setup.py install when building a wheel failed for source
  90. distributions without pyproject.toml (`#8368 <https://github.com/pypa/pip/issues/8368>`_)
  91. - Deprecate -b/--build/--build-dir/--build-directory. Its current behaviour is confusing
  92. and breaks in case different versions of the same distribution need to be built during
  93. the resolution process. Using the TMPDIR/TEMP/TMP environment variable, possibly
  94. combined with --no-clean covers known use cases. (`#8372 <https://github.com/pypa/pip/issues/8372>`_)
  95. - Remove undocumented and deprecated option ``--always-unzip`` (`#8408 <https://github.com/pypa/pip/issues/8408>`_)
  96. Features
  97. --------
  98. - Log debugging information about pip, in ``pip install --verbose``. (`#3166 <https://github.com/pypa/pip/issues/3166>`_)
  99. - Refine error messages to avoid showing Python tracebacks when an HTTP error occurs. (`#5380 <https://github.com/pypa/pip/issues/5380>`_)
  100. - Install wheel files directly instead of extracting them to a temp directory. (`#6030 <https://github.com/pypa/pip/issues/6030>`_)
  101. - Add a beta version of pip's next-generation dependency resolver.
  102. Move pip's new resolver into beta, remove the
  103. ``--unstable-feature=resolver`` flag, and enable the
  104. ``--use-feature=2020-resolver`` flag. The new resolver is
  105. significantly stricter and more consistent when it receives
  106. incompatible instructions, and reduces support for certain kinds of
  107. :ref:`Constraints Files`, so some workarounds and workflows may
  108. break. More details about how to test and migrate, and how to report
  109. issues, at :ref:`Resolver changes 2020` . Maintainers are preparing to
  110. release pip 20.3, with the new resolver on by default, in October. (`#6536 <https://github.com/pypa/pip/issues/6536>`_)
  111. - Introduce a new ResolutionImpossible error, raised when pip encounters un-satisfiable dependency conflicts (`#8546 <https://github.com/pypa/pip/issues/8546>`_, `#8377 <https://github.com/pypa/pip/issues/8377>`_)
  112. - Add a subcommand ``debug`` to ``pip config`` to list available configuration sources and the key-value pairs defined in them. (`#6741 <https://github.com/pypa/pip/issues/6741>`_)
  113. - Warn if index pages have unexpected content-type (`#6754 <https://github.com/pypa/pip/issues/6754>`_)
  114. - Allow specifying ``--prefer-binary`` option in a requirements file (`#7693 <https://github.com/pypa/pip/issues/7693>`_)
  115. - Generate PEP 376 REQUESTED metadata for user supplied requirements installed
  116. by pip. (`#7811 <https://github.com/pypa/pip/issues/7811>`_)
  117. - Warn if package url is a vcs or an archive url with invalid scheme (`#8128 <https://github.com/pypa/pip/issues/8128>`_)
  118. - Parallelize network operations in ``pip list``. (`#8504 <https://github.com/pypa/pip/issues/8504>`_)
  119. - Allow the new resolver to obtain dependency information through wheels
  120. lazily downloaded using HTTP range requests. To enable this feature,
  121. invoke ``pip`` with ``--use-feature=fast-deps``. (`#8588 <https://github.com/pypa/pip/issues/8588>`_)
  122. - Support ``--use-feature`` in requirements files (`#8601 <https://github.com/pypa/pip/issues/8601>`_)
  123. Bug Fixes
  124. ---------
  125. - Use canonical package names while looking up already installed packages. (`#5021 <https://github.com/pypa/pip/issues/5021>`_)
  126. - Fix normalizing path on Windows when installing package on another logical disk. (`#7625 <https://github.com/pypa/pip/issues/7625>`_)
  127. - The VCS commands run by pip as subprocesses don't merge stdout and stderr anymore, improving the output parsing by subsequent commands. (`#7968 <https://github.com/pypa/pip/issues/7968>`_)
  128. - Correctly treat non-ASCII entry point declarations in wheels so they can be
  129. installed on Windows. (`#8342 <https://github.com/pypa/pip/issues/8342>`_)
  130. - Update author email in config and tests to reflect decommissioning of pypa-dev list. (`#8454 <https://github.com/pypa/pip/issues/8454>`_)
  131. - Headers provided by wheels in .data directories are now correctly installed
  132. into the user-provided locations, such as ``--prefix``, instead of the virtual
  133. environment pip is running in. (`#8521 <https://github.com/pypa/pip/issues/8521>`_)
  134. Vendored Libraries
  135. ------------------
  136. - Vendored htmlib5 no longer imports deprecated xml.etree.cElementTree on Python 3.
  137. - Upgrade appdirs to 1.4.4
  138. - Upgrade certifi to 2020.6.20
  139. - Upgrade distlib to 0.3.1
  140. - Upgrade html5lib to 1.1
  141. - Upgrade idna to 2.10
  142. - Upgrade packaging to 20.4
  143. - Upgrade requests to 2.24.0
  144. - Upgrade six to 1.15.0
  145. - Upgrade toml to 0.10.1
  146. - Upgrade urllib3 to 1.25.9
  147. Improved Documentation
  148. ----------------------
  149. - Add ``--no-input`` option to pip docs (`#7688 <https://github.com/pypa/pip/issues/7688>`_)
  150. - List of options supported in requirements file are extracted from source of truth,
  151. instead of being maintained manually. (`#7908 <https://github.com/pypa/pip/issues/7908>`_)
  152. - Fix pip config docstring so that the subcommands render correctly in the docs (`#8072 <https://github.com/pypa/pip/issues/8072>`_)
  153. - replace links to the old pypa-dev mailing list with https://mail.python.org/mailman3/lists/distutils-sig.python.org/ (`#8353 <https://github.com/pypa/pip/issues/8353>`_)
  154. - Fix example for defining multiple values for options which support them (`#8373 <https://github.com/pypa/pip/issues/8373>`_)
  155. - Add documentation for the ResolutionImpossible error that helps the user fix dependency conflicts (`#8459 <https://github.com/pypa/pip/issues/8459>`_)
  156. - Add feature flags to docs (`#8512 <https://github.com/pypa/pip/issues/8512>`_)
  157. - Document how to install package extras from git branch and source distributions. (`#8576 <https://github.com/pypa/pip/issues/8576>`_)
  158. 20.2b1 (2020-05-21)
  159. ===================
  160. Bug Fixes
  161. ---------
  162. - Correctly treat wheels containing non-ASCII file contents so they can be
  163. installed on Windows. (`#5712 <https://github.com/pypa/pip/issues/5712>`_)
  164. - Prompt the user for password if the keyring backend doesn't return one (`#7998 <https://github.com/pypa/pip/issues/7998>`_)
  165. Improved Documentation
  166. ----------------------
  167. - Add GitHub issue template for reporting when the dependency resolver fails (`#8207 <https://github.com/pypa/pip/issues/8207>`_)
  168. 20.1.1 (2020-05-19)
  169. ===================
  170. Deprecations and Removals
  171. -------------------------
  172. - Revert building of local directories in place, restoring the pre-20.1
  173. behaviour of copying to a temporary directory. (`#7555 <https://github.com/pypa/pip/issues/7555>`_)
  174. - Drop parallelization from ``pip list --outdated``. (`#8167 <https://github.com/pypa/pip/issues/8167>`_)
  175. Bug Fixes
  176. ---------
  177. - Fix metadata permission issues when umask has the executable bit set. (`#8164 <https://github.com/pypa/pip/issues/8164>`_)
  178. - Avoid unnecessary message about the wheel package not being installed
  179. when a wheel would not have been built. Additionally, clarify the message. (`#8178 <https://github.com/pypa/pip/issues/8178>`_)
  180. 20.1 (2020-04-28)
  181. =================
  182. Process
  183. -------
  184. - Document that pip 21.0 will drop support for Python 2.7.
  185. Features
  186. --------
  187. - Add ``pip cache dir`` to show the cache directory. (`#7350 <https://github.com/pypa/pip/issues/7350>`_)
  188. Bug Fixes
  189. ---------
  190. - Abort pip cache commands early when cache is disabled. (`#8124 <https://github.com/pypa/pip/issues/8124>`_)
  191. - Correctly set permissions on metadata files during wheel installation,
  192. to permit non-privileged users to read from system site-packages. (`#8139 <https://github.com/pypa/pip/issues/8139>`_)
  193. 20.1b1 (2020-04-21)
  194. ===================
  195. Deprecations and Removals
  196. -------------------------
  197. - Remove emails from AUTHORS.txt to prevent usage for spamming, and only populate names in AUTHORS.txt at time of release (`#5979 <https://github.com/pypa/pip/issues/5979>`_)
  198. - Remove deprecated ``--skip-requirements-regex`` option. (`#7297 <https://github.com/pypa/pip/issues/7297>`_)
  199. - Building of local directories is now done in place, instead of a temporary
  200. location containing a copy of the directory tree. (`#7555 <https://github.com/pypa/pip/issues/7555>`_)
  201. - Remove unused ``tests/scripts/test_all_pip.py`` test script and the ``tests/scripts`` folder. (`#7680 <https://github.com/pypa/pip/issues/7680>`_)
  202. Features
  203. --------
  204. - pip now implements PEP 610, so ``pip freeze`` has better fidelity
  205. in presence of distributions installed from Direct URL requirements. (`#609 <https://github.com/pypa/pip/issues/609>`_)
  206. - Add ``pip cache`` command for inspecting/managing pip's wheel cache. (`#6391 <https://github.com/pypa/pip/issues/6391>`_)
  207. - Raise error if ``--user`` and ``--target`` are used together in ``pip install`` (`#7249 <https://github.com/pypa/pip/issues/7249>`_)
  208. - Significantly improve performance when ``--find-links`` points to a very large HTML page. (`#7729 <https://github.com/pypa/pip/issues/7729>`_)
  209. - Indicate when wheel building is skipped, due to lack of the ``wheel`` package. (`#7768 <https://github.com/pypa/pip/issues/7768>`_)
  210. - Change default behaviour to always cache responses from trusted-host source. (`#7847 <https://github.com/pypa/pip/issues/7847>`_)
  211. - An alpha version of a new resolver is available via ``--unstable-feature=resolver``. (`#988 <https://github.com/pypa/pip/issues/988>`_)
  212. Bug Fixes
  213. ---------
  214. - Correctly freeze a VCS editable package when it is nested inside another VCS repository. (`#3988 <https://github.com/pypa/pip/issues/3988>`_)
  215. - Correctly handle ``%2F`` in URL parameters to avoid accidentally unescape them
  216. into ``/``. (`#6446 <https://github.com/pypa/pip/issues/6446>`_)
  217. - Reject VCS URLs with an empty revision. (`#7402 <https://github.com/pypa/pip/issues/7402>`_)
  218. - Warn when an invalid URL is passed with ``--index-url`` (`#7430 <https://github.com/pypa/pip/issues/7430>`_)
  219. - Use better mechanism for handling temporary files, when recording metadata
  220. about installed files (RECORD) and the installer (INSTALLER). (`#7699 <https://github.com/pypa/pip/issues/7699>`_)
  221. - Correctly detect global site-packages availability of virtual environments
  222. created by PyPA’s virtualenv>=20.0. (`#7718 <https://github.com/pypa/pip/issues/7718>`_)
  223. - Remove current directory from ``sys.path`` when invoked as ``python -m pip <command>`` (`#7731 <https://github.com/pypa/pip/issues/7731>`_)
  224. - Stop failing uninstallation, when trying to remove non-existent files. (`#7856 <https://github.com/pypa/pip/issues/7856>`_)
  225. - Prevent an infinite recursion with ``pip wheel`` when ``$TMPDIR`` is within the source directory. (`#7872 <https://github.com/pypa/pip/issues/7872>`_)
  226. - Significantly speedup ``pip list --outdated`` by parallelizing index interaction. (`#7962 <https://github.com/pypa/pip/issues/7962>`_)
  227. - Improve Windows compatibility when detecting writability in folder. (`#8013 <https://github.com/pypa/pip/issues/8013>`_)
  228. Vendored Libraries
  229. ------------------
  230. - Update semi-supported debundling script to reflect that appdirs is vendored.
  231. - Add ResolveLib as a vendored dependency.
  232. - Upgrade certifi to 2020.04.05.1
  233. - Upgrade contextlib2 to 0.6.0.post1
  234. - Upgrade distro to 1.5.0.
  235. - Upgrade idna to 2.9.
  236. - Upgrade msgpack to 1.0.0.
  237. - Upgrade packaging to 20.3.
  238. - Upgrade pep517 to 0.8.2.
  239. - Upgrade pyparsing to 2.4.7.
  240. - Remove pytoml as a vendored dependency.
  241. - Upgrade requests to 2.23.0.
  242. - Add toml as a vendored dependency.
  243. - Upgrade urllib3 to 1.25.8.
  244. Improved Documentation
  245. ----------------------
  246. - Emphasize that VCS URLs using git, git+git and git+http are insecure due to
  247. lack of authentication and encryption (`#1983 <https://github.com/pypa/pip/issues/1983>`_)
  248. - Clarify the usage of --no-binary command. (`#3191 <https://github.com/pypa/pip/issues/3191>`_)
  249. - Clarify the usage of freeze command in the example of Using pip in your program (`#7008 <https://github.com/pypa/pip/issues/7008>`_)
  250. - Add a "Copyright" page. (`#7767 <https://github.com/pypa/pip/issues/7767>`_)
  251. - Added example of defining multiple values for options which support them (`#7803 <https://github.com/pypa/pip/issues/7803>`_)
  252. 20.0.2 (2020-01-24)
  253. ===================
  254. Bug Fixes
  255. ---------
  256. - Fix a regression in generation of compatibility tags. (`#7626 <https://github.com/pypa/pip/issues/7626>`_)
  257. Vendored Libraries
  258. ------------------
  259. - Upgrade packaging to 20.1
  260. 20.0.1 (2020-01-21)
  261. ===================
  262. Bug Fixes
  263. ---------
  264. - Rename an internal module, to avoid ImportErrors due to improper uninstallation. (`#7621 <https://github.com/pypa/pip/issues/7621>`_)
  265. 20.0 (2020-01-21)
  266. =================
  267. Process
  268. -------
  269. - Switch to a dedicated CLI tool for vendoring dependencies.
  270. Deprecations and Removals
  271. -------------------------
  272. - Remove wheel tag calculation from pip and use ``packaging.tags``. This
  273. should provide more tags ordered better than in prior releases. (`#6908 <https://github.com/pypa/pip/issues/6908>`_)
  274. - Deprecate setup.py-based builds that do not generate an ``.egg-info`` directory. (`#6998 <https://github.com/pypa/pip/issues/6998>`_)
  275. - The pip>=20 wheel cache is not retro-compatible with previous versions. Until
  276. pip 21.0, pip will continue to take advantage of existing legacy cache
  277. entries. (`#7296 <https://github.com/pypa/pip/issues/7296>`_)
  278. - Deprecate undocumented ``--skip-requirements-regex`` option. (`#7297 <https://github.com/pypa/pip/issues/7297>`_)
  279. - Deprecate passing install-location-related options via ``--install-option``. (`#7309 <https://github.com/pypa/pip/issues/7309>`_)
  280. - Use literal "abi3" for wheel tag on CPython 3.x, to align with PEP 384
  281. which only defines it for this platform. (`#7327 <https://github.com/pypa/pip/issues/7327>`_)
  282. - Remove interpreter-specific major version tag e.g. ``cp3-none-any``
  283. from consideration. This behavior was not documented strictly, and this
  284. tag in particular is `not useful <https://snarky.ca/the-challenges-in-designing-a-library-for-pep-425/>`_.
  285. Anyone with a use case can create an issue with pypa/packaging. (`#7355 <https://github.com/pypa/pip/issues/7355>`_)
  286. - Wheel processing no longer permits wheels containing more than one top-level
  287. .dist-info directory. (`#7487 <https://github.com/pypa/pip/issues/7487>`_)
  288. - Support for the ``git+git@`` form of VCS requirement is being deprecated and
  289. will be removed in pip 21.0. Switch to ``git+https://`` or
  290. ``git+ssh://``. ``git+git://`` also works but its use is discouraged as it is
  291. insecure. (`#7543 <https://github.com/pypa/pip/issues/7543>`_)
  292. Features
  293. --------
  294. - Default to doing a user install (as if ``--user`` was passed) when the main
  295. site-packages directory is not writeable and user site-packages are enabled. (`#1668 <https://github.com/pypa/pip/issues/1668>`_)
  296. - Warn if a path in PATH starts with tilde during ``pip install``. (`#6414 <https://github.com/pypa/pip/issues/6414>`_)
  297. - Cache wheels built from Git requirements that are considered immutable,
  298. because they point to a commit hash. (`#6640 <https://github.com/pypa/pip/issues/6640>`_)
  299. - Add option ``--no-python-version-warning`` to silence warnings
  300. related to deprecation of Python versions. (`#6673 <https://github.com/pypa/pip/issues/6673>`_)
  301. - Cache wheels that ``pip wheel`` built locally, matching what
  302. ``pip install`` does. This particularly helps performance in workflows where
  303. ``pip wheel`` is used for `building before installing
  304. <https://pip.pypa.io/en/stable/user_guide/#installing-from-local-packages>`_.
  305. Users desiring the original behavior can use ``pip wheel --no-cache-dir``. (`#6852 <https://github.com/pypa/pip/issues/6852>`_)
  306. - Display CA information in ``pip debug``. (`#7146 <https://github.com/pypa/pip/issues/7146>`_)
  307. - Show only the filename (instead of full URL), when downloading from PyPI. (`#7225 <https://github.com/pypa/pip/issues/7225>`_)
  308. - Suggest a more robust command to upgrade pip itself to avoid confusion when the
  309. current pip command is not available as ``pip``. (`#7376 <https://github.com/pypa/pip/issues/7376>`_)
  310. - Define all old pip console script entrypoints to prevent import issues in
  311. stale wrapper scripts. (`#7498 <https://github.com/pypa/pip/issues/7498>`_)
  312. - The build step of ``pip wheel`` now builds all wheels to a cache first,
  313. then copies them to the wheel directory all at once.
  314. Before, it built them to a temporary directory and moved
  315. them to the wheel directory one by one. (`#7517 <https://github.com/pypa/pip/issues/7517>`_)
  316. - Expand ``~`` prefix to user directory in path options, configs, and
  317. environment variables. Values that may be either URL or path are not
  318. currently supported, to avoid ambiguity:
  319. * ``--find-links``
  320. * ``--constraint``, ``-c``
  321. * ``--requirement``, ``-r``
  322. * ``--editable``, ``-e`` (`#980 <https://github.com/pypa/pip/issues/980>`_)
  323. Bug Fixes
  324. ---------
  325. - Correctly handle system site-packages, in virtual environments created with venv (PEP 405). (`#5702 <https://github.com/pypa/pip/issues/5702>`_, `#7155 <https://github.com/pypa/pip/issues/7155>`_)
  326. - Fix case sensitive comparison of pip freeze when used with -r option. (`#5716 <https://github.com/pypa/pip/issues/5716>`_)
  327. - Enforce PEP 508 requirement format in ``pyproject.toml``
  328. ``build-system.requires``. (`#6410 <https://github.com/pypa/pip/issues/6410>`_)
  329. - Make ``ensure_dir()`` also ignore ``ENOTEMPTY`` as seen on Windows. (`#6426 <https://github.com/pypa/pip/issues/6426>`_)
  330. - Fix building packages which specify ``backend-path`` in pyproject.toml. (`#6599 <https://github.com/pypa/pip/issues/6599>`_)
  331. - Do not attempt to run ``setup.py clean`` after a ``pep517`` build error,
  332. since a ``setup.py`` may not exist in that case. (`#6642 <https://github.com/pypa/pip/issues/6642>`_)
  333. - Fix passwords being visible in the index-url in
  334. "Downloading <url>" message. (`#6783 <https://github.com/pypa/pip/issues/6783>`_)
  335. - Change method from shutil.remove to shutil.rmtree in noxfile.py. (`#7191 <https://github.com/pypa/pip/issues/7191>`_)
  336. - Skip running tests which require subversion, when svn isn't installed (`#7193 <https://github.com/pypa/pip/issues/7193>`_)
  337. - Fix not sending client certificates when using ``--trusted-host``. (`#7207 <https://github.com/pypa/pip/issues/7207>`_)
  338. - Make sure ``pip wheel`` never outputs pure python wheels with a
  339. python implementation tag. Better fix/workaround for
  340. `#3025 <https://github.com/pypa/pip/issues/3025>`_ by
  341. using a per-implementation wheel cache instead of caching pure python
  342. wheels with an implementation tag in their name. (`#7296 <https://github.com/pypa/pip/issues/7296>`_)
  343. - Include ``subdirectory`` URL fragments in cache keys. (`#7333 <https://github.com/pypa/pip/issues/7333>`_)
  344. - Fix typo in warning message when any of ``--build-option``, ``--global-option``
  345. and ``--install-option`` is used in requirements.txt (`#7340 <https://github.com/pypa/pip/issues/7340>`_)
  346. - Fix the logging of cached HTTP response shown as downloading. (`#7393 <https://github.com/pypa/pip/issues/7393>`_)
  347. - Effectively disable the wheel cache when it is not writable, as is the
  348. case with the http cache. (`#7488 <https://github.com/pypa/pip/issues/7488>`_)
  349. - Correctly handle relative cache directory provided via --cache-dir. (`#7541 <https://github.com/pypa/pip/issues/7541>`_)
  350. Vendored Libraries
  351. ------------------
  352. - Upgrade CacheControl to 0.12.5
  353. - Upgrade certifi to 2019.9.11
  354. - Upgrade colorama to 0.4.1
  355. - Upgrade distlib to 0.2.9.post0
  356. - Upgrade ipaddress to 1.0.22
  357. - Update packaging to 20.0.
  358. - Upgrade pkg_resources (via setuptools) to 44.0.0
  359. - Upgrade pyparsing to 2.4.2
  360. - Upgrade six to 1.12.0
  361. - Upgrade urllib3 to 1.25.6
  362. Improved Documentation
  363. ----------------------
  364. - Document that "coding: utf-8" is supported in requirements.txt (`#7182 <https://github.com/pypa/pip/issues/7182>`_)
  365. - Explain how to get pip's source code in `Getting Started <https://pip.pypa.io/en/stable/development/getting-started/>`_ (`#7197 <https://github.com/pypa/pip/issues/7197>`_)
  366. - Describe how basic authentication credentials in URLs work. (`#7201 <https://github.com/pypa/pip/issues/7201>`_)
  367. - Add more clear installation instructions (`#7222 <https://github.com/pypa/pip/issues/7222>`_)
  368. - Fix documentation links for index options (`#7347 <https://github.com/pypa/pip/issues/7347>`_)
  369. - Better document the requirements file format (`#7385 <https://github.com/pypa/pip/issues/7385>`_)
  370. 19.3.1 (2019-10-17)
  371. ===================
  372. Features
  373. --------
  374. - Document Python 3.8 support. (`#7219 <https://github.com/pypa/pip/issues/7219>`_)
  375. Bug Fixes
  376. ---------
  377. - Fix bug that prevented installation of PEP 517 packages without ``setup.py``. (`#6606 <https://github.com/pypa/pip/issues/6606>`_)
  378. 19.3 (2019-10-14)
  379. =================
  380. Deprecations and Removals
  381. -------------------------
  382. - Remove undocumented support for un-prefixed URL requirements pointing
  383. to SVN repositories. Users relying on this can get the original behavior
  384. by prefixing their URL with ``svn+`` (which is backwards-compatible). (`#7037 <https://github.com/pypa/pip/issues/7037>`_)
  385. - Remove the deprecated ``--venv`` option from ``pip config``. (`#7163 <https://github.com/pypa/pip/issues/7163>`_)
  386. Features
  387. --------
  388. - Print a better error message when ``--no-binary`` or ``--only-binary`` is given
  389. an argument starting with ``-``. (`#3191 <https://github.com/pypa/pip/issues/3191>`_)
  390. - Make ``pip show`` warn about packages not found. (`#6858 <https://github.com/pypa/pip/issues/6858>`_)
  391. - Support including a port number in ``--trusted-host`` for both HTTP and HTTPS. (`#6886 <https://github.com/pypa/pip/issues/6886>`_)
  392. - Redact single-part login credentials from URLs in log messages. (`#6891 <https://github.com/pypa/pip/issues/6891>`_)
  393. - Implement manylinux2014 platform tag support. manylinux2014 is the successor
  394. to manylinux2010. It allows carefully compiled binary wheels to be installed
  395. on compatible Linux platforms. The manylinux2014 platform tag definition can
  396. be found in `PEP599 <https://www.python.org/dev/peps/pep-0599/>`_. (`#7102 <https://github.com/pypa/pip/issues/7102>`_)
  397. Bug Fixes
  398. ---------
  399. - Abort installation if any archive contains a file which would be placed
  400. outside the extraction location. (`#3907 <https://github.com/pypa/pip/issues/3907>`_)
  401. - pip's CLI completion code no longer prints a Traceback if it is interrupted. (`#3942 <https://github.com/pypa/pip/issues/3942>`_)
  402. - Correct inconsistency related to the ``hg+file`` scheme. (`#4358 <https://github.com/pypa/pip/issues/4358>`_)
  403. - Fix ``rmtree_errorhandler`` to skip non-existing directories. (`#4910 <https://github.com/pypa/pip/issues/4910>`_)
  404. - Ignore errors copying socket files for local source installs (in Python 3). (`#5306 <https://github.com/pypa/pip/issues/5306>`_)
  405. - Fix requirement line parser to correctly handle PEP 440 requirements with a URL
  406. pointing to an archive file. (`#6202 <https://github.com/pypa/pip/issues/6202>`_)
  407. - The ``pip-wheel-metadata`` directory does not need to persist between invocations of pip, use a temporary directory instead of the current ``setup.py`` directory. (`#6213 <https://github.com/pypa/pip/issues/6213>`_)
  408. - Fix ``--trusted-host`` processing under HTTPS to trust any port number used
  409. with the host. (`#6705 <https://github.com/pypa/pip/issues/6705>`_)
  410. - Switch to new ``distlib`` wheel script template. This should be functionally
  411. equivalent for end users. (`#6763 <https://github.com/pypa/pip/issues/6763>`_)
  412. - Skip copying .tox and .nox directories to temporary build directories (`#6770 <https://github.com/pypa/pip/issues/6770>`_)
  413. - Fix handling of tokens (single part credentials) in URLs. (`#6795 <https://github.com/pypa/pip/issues/6795>`_)
  414. - Fix a regression that caused ``~`` expansion not to occur in ``--find-links``
  415. paths. (`#6804 <https://github.com/pypa/pip/issues/6804>`_)
  416. - Fix bypassed pip upgrade warning on Windows. (`#6841 <https://github.com/pypa/pip/issues/6841>`_)
  417. - Fix 'm' flag erroneously being appended to ABI tag in Python 3.8 on platforms that do not provide SOABI (`#6885 <https://github.com/pypa/pip/issues/6885>`_)
  418. - Hide security-sensitive strings like passwords in log messages related to
  419. version control system (aka VCS) command invocations. (`#6890 <https://github.com/pypa/pip/issues/6890>`_)
  420. - Correctly uninstall symlinks that were installed in a virtualenv,
  421. by tools such as ``flit install --symlink``. (`#6892 <https://github.com/pypa/pip/issues/6892>`_)
  422. - Don't fail installation using pip.exe on Windows when pip wouldn't be upgraded. (`#6924 <https://github.com/pypa/pip/issues/6924>`_)
  423. - Use canonical distribution names when computing ``Required-By`` in ``pip show``. (`#6947 <https://github.com/pypa/pip/issues/6947>`_)
  424. - Don't use hardlinks for locking selfcheck state file. (`#6954 <https://github.com/pypa/pip/issues/6954>`_)
  425. - Ignore "require_virtualenv" in ``pip config`` (`#6991 <https://github.com/pypa/pip/issues/6991>`_)
  426. - Fix ``pip freeze`` not showing correct entry for mercurial packages that use subdirectories. (`#7071 <https://github.com/pypa/pip/issues/7071>`_)
  427. - Fix a crash when ``sys.stdin`` is set to ``None``, such as on AWS Lambda. (`#7118 <https://github.com/pypa/pip/issues/7118>`_, `#7119 <https://github.com/pypa/pip/issues/7119>`_)
  428. Vendored Libraries
  429. ------------------
  430. - Upgrade certifi to 2019.9.11
  431. - Add contextlib2 0.6.0 as a vendored dependency.
  432. - Remove Lockfile as a vendored dependency.
  433. - Upgrade msgpack to 0.6.2
  434. - Upgrade packaging to 19.2
  435. - Upgrade pep517 to 0.7.0
  436. - Upgrade pyparsing to 2.4.2
  437. - Upgrade pytoml to 0.1.21
  438. - Upgrade setuptools to 41.4.0
  439. - Upgrade urllib3 to 1.25.6
  440. Improved Documentation
  441. ----------------------
  442. - Document caveats for UNC paths in uninstall and add .pth unit tests. (`#6516 <https://github.com/pypa/pip/issues/6516>`_)
  443. - Add architectural overview documentation. (`#6637 <https://github.com/pypa/pip/issues/6637>`_)
  444. - Document that ``--ignore-installed`` is dangerous. (`#6794 <https://github.com/pypa/pip/issues/6794>`_)
  445. 19.2.3 (2019-08-25)
  446. ===================
  447. Bug Fixes
  448. ---------
  449. - Fix 'm' flag erroneously being appended to ABI tag in Python 3.8 on platforms that do not provide SOABI (`#6885 <https://github.com/pypa/pip/issues/6885>`_)
  450. 19.2.2 (2019-08-11)
  451. ===================
  452. Bug Fixes
  453. ---------
  454. - Fix handling of tokens (single part credentials) in URLs. (`#6795 <https://github.com/pypa/pip/issues/6795>`_)
  455. - Fix a regression that caused ``~`` expansion not to occur in ``--find-links``
  456. paths. (`#6804 <https://github.com/pypa/pip/issues/6804>`_)
  457. 19.2.1 (2019-07-23)
  458. ===================
  459. Bug Fixes
  460. ---------
  461. - Fix a ``NoneType`` ``AttributeError`` when evaluating hashes and no hashes
  462. are provided. (`#6772 <https://github.com/pypa/pip/issues/6772>`_)
  463. 19.2 (2019-07-22)
  464. =================
  465. Deprecations and Removals
  466. -------------------------
  467. - Drop support for EOL Python 3.4. (`#6685 <https://github.com/pypa/pip/issues/6685>`_)
  468. - Improve deprecation messages to include the version in which the functionality will be removed. (`#6549 <https://github.com/pypa/pip/issues/6549>`_)
  469. Features
  470. --------
  471. - Credentials will now be loaded using `keyring` when installed. (`#5948 <https://github.com/pypa/pip/issues/5948>`_)
  472. - Fully support using ``--trusted-host`` inside requirements files. (`#3799 <https://github.com/pypa/pip/issues/3799>`_)
  473. - Update timestamps in pip's ``--log`` file to include milliseconds. (`#6587 <https://github.com/pypa/pip/issues/6587>`_)
  474. - Respect whether a file has been marked as "yanked" from a simple repository
  475. (see `PEP 592 <https://www.python.org/dev/peps/pep-0592/>`__ for details). (`#6633 <https://github.com/pypa/pip/issues/6633>`_)
  476. - When choosing candidates to install, prefer candidates with a hash matching
  477. one of the user-provided hashes. (`#5874 <https://github.com/pypa/pip/issues/5874>`_)
  478. - Improve the error message when ``METADATA`` or ``PKG-INFO`` is None when
  479. accessing metadata. (`#5082 <https://github.com/pypa/pip/issues/5082>`_)
  480. - Add a new command ``pip debug`` that can display e.g. the list of compatible
  481. tags for the current Python. (`#6638 <https://github.com/pypa/pip/issues/6638>`_)
  482. - Display hint on installing with --pre when search results include pre-release versions. (`#5169 <https://github.com/pypa/pip/issues/5169>`_)
  483. - Report to Warehouse that pip is running under CI if the ``PIP_IS_CI`` environment variable is set. (`#5499 <https://github.com/pypa/pip/issues/5499>`_)
  484. - Allow ``--python-version`` to be passed as a dotted version string (e.g.
  485. ``3.7`` or ``3.7.3``). (`#6585 <https://github.com/pypa/pip/issues/6585>`_)
  486. - Log the final filename and SHA256 of a ``.whl`` file when done building a
  487. wheel. (`#5908 <https://github.com/pypa/pip/issues/5908>`_)
  488. - Include the wheel's tags in the log message explanation when a candidate
  489. wheel link is found incompatible. (`#6121 <https://github.com/pypa/pip/issues/6121>`_)
  490. - Add a ``--path`` argument to ``pip freeze`` to support ``--target``
  491. installations. (`#6404 <https://github.com/pypa/pip/issues/6404>`_)
  492. - Add a ``--path`` argument to ``pip list`` to support ``--target``
  493. installations. (`#6551 <https://github.com/pypa/pip/issues/6551>`_)
  494. Bug Fixes
  495. ---------
  496. - Set ``sys.argv[0]`` to the underlying ``setup.py`` when invoking ``setup.py``
  497. via the setuptools shim so setuptools doesn't think the path is ``-c``. (`#1890 <https://github.com/pypa/pip/issues/1890>`_)
  498. - Update ``pip download`` to respect the given ``--python-version`` when checking
  499. ``"Requires-Python"``. (`#5369 <https://github.com/pypa/pip/issues/5369>`_)
  500. - Respect ``--global-option`` and ``--install-option`` when installing from
  501. a version control url (e.g. ``git``). (`#5518 <https://github.com/pypa/pip/issues/5518>`_)
  502. - Make the "ascii" progress bar really be "ascii" and not Unicode. (`#5671 <https://github.com/pypa/pip/issues/5671>`_)
  503. - Fail elegantly when trying to set an incorrectly formatted key in config. (`#5963 <https://github.com/pypa/pip/issues/5963>`_)
  504. - Prevent DistutilsOptionError when prefix is indicated in the global environment and `--target` is used. (`#6008 <https://github.com/pypa/pip/issues/6008>`_)
  505. - Fix ``pip install`` to respect ``--ignore-requires-python`` when evaluating
  506. links. (`#6371 <https://github.com/pypa/pip/issues/6371>`_)
  507. - Fix a debug log message when freezing an editable, non-version controlled
  508. requirement. (`#6383 <https://github.com/pypa/pip/issues/6383>`_)
  509. - Extend to Subversion 1.8+ the behavior of calling Subversion in
  510. interactive mode when pip is run interactively. (`#6386 <https://github.com/pypa/pip/issues/6386>`_)
  511. - Prevent ``pip install <url>`` from permitting directory traversal if e.g.
  512. a malicious server sends a ``Content-Disposition`` header with a filename
  513. containing ``../`` or ``..\\``. (`#6413 <https://github.com/pypa/pip/issues/6413>`_)
  514. - Hide passwords in output when using ``--find-links``. (`#6489 <https://github.com/pypa/pip/issues/6489>`_)
  515. - Include more details in the log message if ``pip freeze`` can't generate a
  516. requirement string for a particular distribution. (`#6513 <https://github.com/pypa/pip/issues/6513>`_)
  517. - Add the line number and file location to the error message when reading an
  518. invalid requirements file in certain situations. (`#6527 <https://github.com/pypa/pip/issues/6527>`_)
  519. - Prefer ``os.confstr`` to ``ctypes`` when extracting glibc version info. (`#6543 <https://github.com/pypa/pip/issues/6543>`_, `#6675 <https://github.com/pypa/pip/issues/6675>`_)
  520. - Improve error message printed when an invalid editable requirement is provided. (`#6648 <https://github.com/pypa/pip/issues/6648>`_)
  521. - Improve error message formatting when a command errors out in a subprocess. (`#6651 <https://github.com/pypa/pip/issues/6651>`_)
  522. Vendored Libraries
  523. ------------------
  524. - Upgrade certifi to 2019.6.16
  525. - Upgrade distlib to 0.2.9.post0
  526. - Upgrade msgpack to 0.6.1
  527. - Upgrade requests to 2.22.0
  528. - Upgrade urllib3 to 1.25.3
  529. - Patch vendored html5lib, to prefer using `collections.abc` where possible.
  530. Improved Documentation
  531. ----------------------
  532. - Document how Python 2.7 support will be maintained. (`#6726 <https://github.com/pypa/pip/issues/6726>`_)
  533. - Upgrade Sphinx version used to build documentation. (`#6471 <https://github.com/pypa/pip/issues/6471>`_)
  534. - Fix generation of subcommand manpages. (`#6724 <https://github.com/pypa/pip/issues/6724>`_)
  535. - Mention that pip can install from git refs. (`#6512 <https://github.com/pypa/pip/issues/6512>`_)
  536. - Replace a failing example of pip installs with extras with a working one. (`#4733 <https://github.com/pypa/pip/issues/4733>`_)
  537. 19.1.1 (2019-05-06)
  538. ===================
  539. Features
  540. --------
  541. - Restore ``pyproject.toml`` handling to how it was with pip 19.0.3 to prevent
  542. the need to add ``--no-use-pep517`` when installing in editable mode. (`#6434 <https://github.com/pypa/pip/issues/6434>`_)
  543. Bug Fixes
  544. ---------
  545. - Fix a regression that caused `@` to be quoted in pypiserver links.
  546. This interfered with parsing the revision string from VCS urls. (`#6440 <https://github.com/pypa/pip/issues/6440>`_)
  547. 19.1 (2019-04-23)
  548. =================
  549. Features
  550. --------
  551. - Configuration files may now also be stored under ``sys.prefix`` (`#5060 <https://github.com/pypa/pip/issues/5060>`_)
  552. - Avoid creating an unnecessary local clone of a Bazaar branch when exporting. (`#5443 <https://github.com/pypa/pip/issues/5443>`_)
  553. - Include in pip's User-Agent string whether it looks like pip is running
  554. under CI. (`#5499 <https://github.com/pypa/pip/issues/5499>`_)
  555. - A custom (JSON-encoded) string can now be added to pip's User-Agent
  556. using the ``PIP_USER_AGENT_USER_DATA`` environment variable. (`#5549 <https://github.com/pypa/pip/issues/5549>`_)
  557. - For consistency, passing ``--no-cache-dir`` no longer affects whether wheels
  558. will be built. In this case, a temporary directory is used. (`#5749 <https://github.com/pypa/pip/issues/5749>`_)
  559. - Command arguments in ``subprocess`` log messages are now quoted using
  560. ``shlex.quote()``. (`#6290 <https://github.com/pypa/pip/issues/6290>`_)
  561. - Prefix warning and error messages in log output with `WARNING` and `ERROR`. (`#6298 <https://github.com/pypa/pip/issues/6298>`_)
  562. - Using ``--build-options`` in a PEP 517 build now fails with an error,
  563. rather than silently ignoring the option. (`#6305 <https://github.com/pypa/pip/issues/6305>`_)
  564. - Error out with an informative message if one tries to install a
  565. ``pyproject.toml``-style (PEP 517) source tree using ``--editable`` mode. (`#6314 <https://github.com/pypa/pip/issues/6314>`_)
  566. - When downloading a package, the ETA and average speed now only update once per second for better legibility. (`#6319 <https://github.com/pypa/pip/issues/6319>`_)
  567. Bug Fixes
  568. ---------
  569. - The stdout and stderr from VCS commands run by pip as subprocesses (e.g.
  570. ``git``, ``hg``, etc.) no longer pollute pip's stdout. (`#1219 <https://github.com/pypa/pip/issues/1219>`_)
  571. - Fix handling of requests exceptions when dependencies are debundled. (`#4195 <https://github.com/pypa/pip/issues/4195>`_)
  572. - Make pip's self version check avoid recommending upgrades to prereleases if the currently-installed version is stable. (`#5175 <https://github.com/pypa/pip/issues/5175>`_)
  573. - Fixed crash when installing a requirement from a URL that comes from a dependency without a URL. (`#5889 <https://github.com/pypa/pip/issues/5889>`_)
  574. - Improve handling of file URIs: correctly handle `file://localhost/...` and don't try to use UNC paths on Unix. (`#5892 <https://github.com/pypa/pip/issues/5892>`_)
  575. - Fix ``utils.encoding.auto_decode()`` ``LookupError`` with invalid encodings.
  576. ``utils.encoding.auto_decode()`` was broken when decoding Big Endian BOM
  577. byte-strings on Little Endian or vice versa. (`#6054 <https://github.com/pypa/pip/issues/6054>`_)
  578. - Fix incorrect URL quoting of IPv6 addresses. (`#6285 <https://github.com/pypa/pip/issues/6285>`_)
  579. - Redact the password from the extra index URL when using ``pip -v``. (`#6295 <https://github.com/pypa/pip/issues/6295>`_)
  580. - The spinner no longer displays a completion message after subprocess calls
  581. not needing a spinner. It also no longer incorrectly reports an error after
  582. certain subprocess calls to Git that succeeded. (`#6312 <https://github.com/pypa/pip/issues/6312>`_)
  583. - Fix the handling of editable mode during installs when ``pyproject.toml`` is
  584. present but PEP 517 doesn't require the source tree to be treated as
  585. ``pyproject.toml``-style. (`#6370 <https://github.com/pypa/pip/issues/6370>`_)
  586. - Fix ``NameError`` when handling an invalid requirement. (`#6419 <https://github.com/pypa/pip/issues/6419>`_)
  587. Vendored Libraries
  588. ------------------
  589. - Updated certifi to 2019.3.9
  590. - Updated distro to 1.4.0
  591. - Update progress to 1.5
  592. - Updated pyparsing to 2.4.0
  593. - Updated pkg_resources to 41.0.1 (via setuptools)
  594. Improved Documentation
  595. ----------------------
  596. - Make dashes render correctly when displaying long options like
  597. ``--find-links`` in the text. (`#6422 <https://github.com/pypa/pip/issues/6422>`_)
  598. 19.0.3 (2019-02-20)
  599. ===================
  600. Bug Fixes
  601. ---------
  602. - Fix an ``IndexError`` crash when a legacy build of a wheel fails. (`#6252 <https://github.com/pypa/pip/issues/6252>`_)
  603. - Fix a regression introduced in 19.0.2 where the filename in a RECORD file
  604. of an installed file would not be updated when installing a wheel. (`#6266 <https://github.com/pypa/pip/issues/6266>`_)
  605. 19.0.2 (2019-02-09)
  606. ===================
  607. Bug Fixes
  608. ---------
  609. - Fix a crash where PEP 517-based builds using ``--no-cache-dir`` would fail in
  610. some circumstances with an ``AssertionError`` due to not finalizing a build
  611. directory internally. (`#6197 <https://github.com/pypa/pip/issues/6197>`_)
  612. - Provide a better error message if attempting an editable install of a
  613. directory with a ``pyproject.toml`` but no ``setup.py``. (`#6170 <https://github.com/pypa/pip/issues/6170>`_)
  614. - The implicit default backend used for projects that provide a ``pyproject.toml``
  615. file without explicitly specifying ``build-backend`` now behaves more like direct
  616. execution of ``setup.py``, and hence should restore compatibility with projects
  617. that were unable to be installed with ``pip`` 19.0. This raised the minimum
  618. required version of ``setuptools`` for such builds to 40.8.0. (`#6163 <https://github.com/pypa/pip/issues/6163>`_)
  619. - Allow ``RECORD`` lines with more than three elements, and display a warning. (`#6165 <https://github.com/pypa/pip/issues/6165>`_)
  620. - ``AdjacentTempDirectory`` fails on unwritable directory instead of locking up the uninstall command. (`#6169 <https://github.com/pypa/pip/issues/6169>`_)
  621. - Make failed uninstalls roll back more reliably and better at avoiding naming conflicts. (`#6194 <https://github.com/pypa/pip/issues/6194>`_)
  622. - Ensure the correct wheel file is copied when building PEP 517 distribution is built. (`#6196 <https://github.com/pypa/pip/issues/6196>`_)
  623. - The Python 2 end of life warning now only shows on CPython, which is the
  624. implementation that has announced end of life plans. (`#6207 <https://github.com/pypa/pip/issues/6207>`_)
  625. Improved Documentation
  626. ----------------------
  627. - Re-write README and documentation index (`#5815 <https://github.com/pypa/pip/issues/5815>`_)
  628. 19.0.1 (2019-01-23)
  629. ===================
  630. Bug Fixes
  631. ---------
  632. - Fix a crash when using --no-cache-dir with PEP 517 distributions (`#6158 <https://github.com/pypa/pip/issues/6158>`_, `#6171 <https://github.com/pypa/pip/issues/6171>`_)
  633. 19.0 (2019-01-22)
  634. =================
  635. Deprecations and Removals
  636. -------------------------
  637. - Deprecate support for Python 3.4 (`#6106 <https://github.com/pypa/pip/issues/6106>`_)
  638. - Start printing a warning for Python 2.7 to warn of impending Python 2.7 End-of-life and
  639. prompt users to start migrating to Python 3. (`#6148 <https://github.com/pypa/pip/issues/6148>`_)
  640. - Remove the deprecated ``--process-dependency-links`` option. (`#6060 <https://github.com/pypa/pip/issues/6060>`_)
  641. - Remove the deprecated SVN editable detection based on dependency links
  642. during freeze. (`#5866 <https://github.com/pypa/pip/issues/5866>`_)
  643. Features
  644. --------
  645. - Implement PEP 517 (allow projects to specify a build backend via pyproject.toml). (`#5743 <https://github.com/pypa/pip/issues/5743>`_)
  646. - Implement manylinux2010 platform tag support. manylinux2010 is the successor
  647. to manylinux1. It allows carefully compiled binary wheels to be installed
  648. on compatible Linux platforms. (`#5008 <https://github.com/pypa/pip/issues/5008>`_)
  649. - Improve build isolation: handle ``.pth`` files, so namespace packages are correctly supported under Python 3.2 and earlier. (`#5656 <https://github.com/pypa/pip/issues/5656>`_)
  650. - Include the package name in a freeze warning if the package is not installed. (`#5943 <https://github.com/pypa/pip/issues/5943>`_)
  651. - Warn when dropping an ``--[extra-]index-url`` value that points to an existing local directory. (`#5827 <https://github.com/pypa/pip/issues/5827>`_)
  652. - Prefix pip's ``--log`` file lines with their timestamp. (`#6141 <https://github.com/pypa/pip/issues/6141>`_)
  653. Bug Fixes
  654. ---------
  655. - Avoid creating excessively long temporary paths when uninstalling packages. (`#3055 <https://github.com/pypa/pip/issues/3055>`_)
  656. - Redact the password from the URL in various log messages. (`#4746 <https://github.com/pypa/pip/issues/4746>`_, `#6124 <https://github.com/pypa/pip/issues/6124>`_)
  657. - Avoid creating excessively long temporary paths when uninstalling packages. (`#3055 <https://github.com/pypa/pip/issues/3055>`_)
  658. - Avoid printing a stack trace when given an invalid requirement. (`#5147 <https://github.com/pypa/pip/issues/5147>`_)
  659. - Present 401 warning if username/password do not work for URL (`#4833 <https://github.com/pypa/pip/issues/4833>`_)
  660. - Handle ``requests.exceptions.RetryError`` raised in ``PackageFinder`` that was causing pip to fail silently when some indexes were unreachable. (`#5270 <https://github.com/pypa/pip/issues/5270>`_, `#5483 <https://github.com/pypa/pip/issues/5483>`_)
  661. - Handle a broken stdout pipe more gracefully (e.g. when running ``pip list | head``). (`#4170 <https://github.com/pypa/pip/issues/4170>`_)
  662. - Fix crash from setting ``PIP_NO_CACHE_DIR=yes``. (`#5385 <https://github.com/pypa/pip/issues/5385>`_)
  663. - Fix crash from unparsable requirements when checking installed packages. (`#5839 <https://github.com/pypa/pip/issues/5839>`_)
  664. - Fix content type detection if a directory named like an archive is used as a package source. (`#5838 <https://github.com/pypa/pip/issues/5838>`_)
  665. - Fix listing of outdated packages that are not dependencies of installed packages in ``pip list --outdated --not-required`` (`#5737 <https://github.com/pypa/pip/issues/5737>`_)
  666. - Fix sorting ``TypeError`` in ``move_wheel_files()`` when installing some packages. (`#5868 <https://github.com/pypa/pip/issues/5868>`_)
  667. - Fix support for invoking pip using ``python src/pip ...``. (`#5841 <https://github.com/pypa/pip/issues/5841>`_)
  668. - Greatly reduce memory usage when installing wheels containing large files. (`#5848 <https://github.com/pypa/pip/issues/5848>`_)
  669. - Editable non-VCS installs now freeze as editable. (`#5031 <https://github.com/pypa/pip/issues/5031>`_)
  670. - Editable Git installs without a remote now freeze as editable. (`#4759 <https://github.com/pypa/pip/issues/4759>`_)
  671. - Canonicalize sdist file names so they can be matched to a canonicalized package name passed to ``pip install``. (`#5870 <https://github.com/pypa/pip/issues/5870>`_)
  672. - Properly decode special characters in SVN URL credentials. (`#5968 <https://github.com/pypa/pip/issues/5968>`_)
  673. - Make ``PIP_NO_CACHE_DIR`` disable the cache also for truthy values like ``"true"``, ``"yes"``, ``"1"``, etc. (`#5735 <https://github.com/pypa/pip/issues/5735>`_)
  674. Vendored Libraries
  675. ------------------
  676. - Include license text of vendored 3rd party libraries. (`#5213 <https://github.com/pypa/pip/issues/5213>`_)
  677. - Update certifi to 2018.11.29
  678. - Update colorama to 0.4.1
  679. - Update distlib to 0.2.8
  680. - Update idna to 2.8
  681. - Update packaging to 19.0
  682. - Update pep517 to 0.5.0
  683. - Update pkg_resources to 40.6.3 (via setuptools)
  684. - Update pyparsing to 2.3.1
  685. - Update pytoml to 0.1.20
  686. - Update requests to 2.21.0
  687. - Update six to 1.12.0
  688. - Update urllib3 to 1.24.1
  689. Improved Documentation
  690. ----------------------
  691. - Include the Vendoring Policy in the documentation. (`#5958 <https://github.com/pypa/pip/issues/5958>`_)
  692. - Add instructions for running pip from source to Development documentation. (`#5949 <https://github.com/pypa/pip/issues/5949>`_)
  693. - Remove references to removed ``#egg=<name>-<version>`` functionality (`#5888 <https://github.com/pypa/pip/issues/5888>`_)
  694. - Fix omission of command name in HTML usage documentation (`#5984 <https://github.com/pypa/pip/issues/5984>`_)
  695. 18.1 (2018-10-05)
  696. =================
  697. Features
  698. --------
  699. - Allow PEP 508 URL requirements to be used as dependencies.
  700. As a security measure, pip will raise an exception when installing packages from
  701. PyPI if those packages depend on packages not also hosted on PyPI.
  702. In the future, PyPI will block uploading packages with such external URL dependencies directly. (`#4187 <https://github.com/pypa/pip/issues/4187>`_)
  703. - Allows dist options (--abi, --python-version, --platform, --implementation) when installing with --target (`#5355 <https://github.com/pypa/pip/issues/5355>`_)
  704. - Support passing ``svn+ssh`` URLs with a username to ``pip install -e``. (`#5375 <https://github.com/pypa/pip/issues/5375>`_)
  705. - pip now ensures that the RECORD file is sorted when installing from a wheel file. (`#5525 <https://github.com/pypa/pip/issues/5525>`_)
  706. - Add support for Python 3.7. (`#5561 <https://github.com/pypa/pip/issues/5561>`_)
  707. - Malformed configuration files now show helpful error messages, instead of tracebacks. (`#5798 <https://github.com/pypa/pip/issues/5798>`_)
  708. Bug Fixes
  709. ---------
  710. - Checkout the correct branch when doing an editable Git install. (`#2037 <https://github.com/pypa/pip/issues/2037>`_)
  711. - Run self-version-check only on commands that may access the index, instead of
  712. trying on every run and failing to do so due to missing options. (`#5433 <https://github.com/pypa/pip/issues/5433>`_)
  713. - Allow a Git ref to be installed over an existing installation. (`#5624 <https://github.com/pypa/pip/issues/5624>`_)
  714. - Show a better error message when a configuration option has an invalid value. (`#5644 <https://github.com/pypa/pip/issues/5644>`_)
  715. - Always revalidate cached simple API pages instead of blindly caching them for up to 10
  716. minutes. (`#5670 <https://github.com/pypa/pip/issues/5670>`_)
  717. - Avoid caching self-version-check information when cache is disabled. (`#5679 <https://github.com/pypa/pip/issues/5679>`_)
  718. - Avoid traceback printing on autocomplete after flags in the CLI. (`#5751 <https://github.com/pypa/pip/issues/5751>`_)
  719. - Fix incorrect parsing of egg names if pip needs to guess the package name. (`#5819 <https://github.com/pypa/pip/issues/5819>`_)
  720. Vendored Libraries
  721. ------------------
  722. - Upgrade certifi to 2018.8.24
  723. - Upgrade packaging to 18.0
  724. - Upgrade pyparsing to 2.2.1
  725. - Add pep517 version 0.2
  726. - Upgrade pytoml to 0.1.19
  727. - Upgrade pkg_resources to 40.4.3 (via setuptools)
  728. Improved Documentation
  729. ----------------------
  730. - Fix "Requirements Files" reference in User Guide (`#user_guide_fix_requirements_file_ref <https://github.com/pypa/pip/issues/user_guide_fix_requirements_file_ref>`_)
  731. 18.0 (2018-07-22)
  732. =================
  733. Process
  734. -------
  735. - Switch to a Calendar based versioning scheme.
  736. - Formally document our deprecation process as a minimum of 6 months of deprecation
  737. warnings.
  738. - Adopt and document NEWS fragment writing style.
  739. - Switch to releasing a new, non-bug fix version of pip every 3 months.
  740. Deprecations and Removals
  741. -------------------------
  742. - Remove the legacy format from pip list. (#3651, #3654)
  743. - Dropped support for Python 3.3. (#3796)
  744. - Remove support for cleaning up #egg fragment postfixes. (#4174)
  745. - Remove the shim for the old get-pip.py location. (#5520)
  746. For the past 2 years, it's only been redirecting users to use the newer
  747. https://bootstrap.pypa.io/get-pip.py location.
  748. Features
  749. --------
  750. - Introduce a new --prefer-binary flag, to prefer older wheels over newer source packages. (#3785)
  751. - Improve autocompletion function on file name completion after options
  752. which have ``<file>``, ``<dir>`` or ``<path>`` as metavar. (#4842, #5125)
  753. - Add support for installing PEP 518 build dependencies from source. (#5229)
  754. - Improve status message when upgrade is skipped due to only-if-needed strategy. (#5319)
  755. Bug Fixes
  756. ---------
  757. - Update pip's self-check logic to not use a virtualenv specific file and honor cache-dir. (#3905)
  758. - Remove compiled pyo files for wheel packages. (#4471)
  759. - Speed up printing of newly installed package versions. (#5127)
  760. - Restrict install time dependency warnings to directly-dependant packages. (#5196, #5457)
  761. Warning about the entire package set has resulted in users getting confused as
  762. to why pip is printing these warnings.
  763. - Improve handling of PEP 518 build requirements: support environment markers and extras. (#5230, #5265)
  764. - Remove username/password from log message when using index with basic auth. (#5249)
  765. - Remove trailing os.sep from PATH directories to avoid false negatives. (#5293)
  766. - Fix "pip wheel pip" being blocked by the "don't use pip to modify itself" check. (#5311, #5312)
  767. - Disable pip's version check (and upgrade message) when installed by a different package manager. (#5346)
  768. This works better with Linux distributions where pip's upgrade message may
  769. result in users running pip in a manner that modifies files that should be
  770. managed by the OS's package manager.
  771. - Check for file existence and unlink first when clobbering existing files during a wheel install. (#5366)
  772. - Improve error message to be more specific when no files are found as listed in as listed in PKG-INFO. (#5381)
  773. - Always read ``pyproject.toml`` as UTF-8. This fixes Unicode handling on Windows and Python 2. (#5482)
  774. - Fix a crash that occurs when PATH not set, while generating script location warning. (#5558)
  775. - Disallow packages with ``pyproject.toml`` files that have an empty build-system table. (#5627)
  776. Vendored Libraries
  777. ------------------
  778. - Update CacheControl to 0.12.5.
  779. - Update certifi to 2018.4.16.
  780. - Update distro to 1.3.0.
  781. - Update idna to 2.7.
  782. - Update ipaddress to 1.0.22.
  783. - Update pkg_resources to 39.2.0 (via setuptools).
  784. - Update progress to 1.4.
  785. - Update pytoml to 0.1.16.
  786. - Update requests to 2.19.1.
  787. - Update urllib3 to 1.23.
  788. Improved Documentation
  789. ----------------------
  790. - Document how to use pip with a proxy server. (#512, #5574)
  791. - Document that the output of pip show is in RFC-compliant mail header format. (#5261)
  792. 10.0.1 (2018-04-19)
  793. ===================
  794. Features
  795. --------
  796. - Switch the default repository to the new "PyPI 2.0" running at
  797. https://pypi.org/. (#5214)
  798. Bug Fixes
  799. ---------
  800. - Fix a bug that made get-pip.py unusable on Windows without renaming. (#5219)
  801. - Fix a TypeError when loading the cache on older versions of Python 2.7.
  802. (#5231)
  803. - Fix and improve error message when EnvironmentError occurs during
  804. installation. (#5237)
  805. - A crash when reinstalling from VCS requirements has been fixed. (#5251)
  806. - Fix PEP 518 support when pip is installed in the user site. (#5524)
  807. Vendored Libraries
  808. ------------------
  809. - Upgrade distlib to 0.2.7
  810. 10.0.0 (2018-04-14)
  811. ===================
  812. Bug Fixes
  813. ---------
  814. - Prevent false-positive installation warnings due to incomplete name
  815. normalization. (#5134)
  816. - Fix issue where installing from Git with a short SHA would fail. (#5140)
  817. - Accept pre-release versions when checking for conflicts with pip check or pip
  818. install. (#5141)
  819. - ``ioctl(fd, termios.TIOCGWINSZ, ...)`` needs 8 bytes of data (#5150)
  820. - Do not warn about script location when installing to the directory containing
  821. sys.executable. This is the case when 'pip install'ing without activating a
  822. virtualenv. (#5157)
  823. - Fix PEP 518 support. (#5188)
  824. - Don't warn about script locations if ``--target`` is specified. (#5203)
  825. 10.0.0b2 (2018-04-02)
  826. =====================
  827. Bug Fixes
  828. ---------
  829. - Fixed line endings in CA Bundle - 10.0.0b1 was inadvertently released with Windows
  830. line endings. (#5131)
  831. 10.0.0b1 (2018-03-31)
  832. =====================
  833. Deprecations and Removals
  834. -------------------------
  835. - Removed the deprecated ``--egg`` parameter to ``pip install``. (#1749)
  836. - Removed support for uninstalling projects which have been installed using
  837. distutils. distutils installed projects do not include metadata indicating
  838. what files belong to that install and thus it is impossible to *actually*
  839. uninstall them rather than just remove the metadata saying they've been
  840. installed while leaving all of the actual files behind. (#2386)
  841. - Removed the deprecated ``--download`` option to ``pip install``. (#2643)
  842. - Removed the deprecated --(no-)use-wheel flags to ``pip install`` and ``pip
  843. wheel``. (#2699)
  844. - Removed the deprecated ``--allow-external``, ``--allow-all-external``, and
  845. ``--allow-unverified`` options. (#3070)
  846. - Switch the default for ``pip list`` to the columns format, and deprecate the
  847. legacy format. (#3654, #3686)
  848. - Deprecate support for Python 3.3. (#3796)
  849. - Removed the deprecated ``--default-vcs`` option. (#4052)
  850. - Removed the ``setup.py test`` support from our sdist as it wasn't being
  851. maintained as a supported means to run our tests. (#4203)
  852. - Dropped support for Python 2.6. (#4343)
  853. - Removed the --editable flag from pip download, as it did not make sense
  854. (#4362)
  855. - Deprecate SVN detection based on dependency links in ``pip freeze``. (#4449)
  856. - Move all of pip's APIs into the pip._internal package, properly reflecting
  857. the fact that pip does not currently have any public APIs. (#4696, #4700)
  858. Features
  859. --------
  860. - Add `--progress-bar <progress_bar>` to ``pip download``, ``pip install`` and
  861. ``pip wheel`` commands, to allow selecting a specific progress indicator or,
  862. to completely suppress, (for example in a CI environment) use
  863. ``--progress-bar off```. (#2369, #2756)
  864. - Add `--no-color` to `pip`. All colored output is disabled if this flag is
  865. detected. (#2449)
  866. - pip uninstall now ignores the absence of a requirement and prints a warning.
  867. (#3016, #4642)
  868. - Improved the memory and disk efficiency of the HTTP cache. (#3515)
  869. - Support for packages specifying build dependencies in pyproject.toml (see
  870. `PEP 518 <https://www.python.org/dev/peps/pep-0518/>`__). Packages which
  871. specify one or more build dependencies this way will be built into wheels in
  872. an isolated environment with those dependencies installed. (#3691)
  873. - pip now supports environment variable expansion in requirement files using
  874. only ``${VARIABLE}`` syntax on all platforms. (#3728)
  875. - Allowed combinations of -q and -v to act sanely. Then we don't need warnings
  876. mentioned in the issue. (#4008)
  877. - Add `--exclude-editable` to ``pip freeze`` and ``pip list`` to exclude
  878. editable packages from installed package list. (#4015, #4016)
  879. - Improve the error message for the common ``pip install ./requirements.txt``
  880. case. (#4127)
  881. - Add support for the new ``@ url`` syntax from PEP 508. (#4175)
  882. - Add setuptools version to the statistics sent to BigQuery. (#4209)
  883. - Report the line which caused the hash error when using requirement files.
  884. (#4227)
  885. - Add a pip config command for managing configuration files. (#4240)
  886. - Allow ``pip download`` to be used with a specific platform when ``--no-deps``
  887. is set. (#4289)
  888. - Support build-numbers in wheel versions and support sorting with
  889. build-numbers. (#4299)
  890. - Change pip outdated to use PackageFinder in order to do the version lookup so
  891. that local mirrors in Environments that do not have Internet connections can
  892. be used as the Source of Truth for latest version. (#4336)
  893. - pip now retries on more HTTP status codes, for intermittent failures.
  894. Previously, it only retried on the standard 503. Now, it also retries on 500
  895. (transient failures on AWS S3), 520 and 527 (transient failures on
  896. Cloudflare). (#4473)
  897. - pip now displays where it is looking for packages, if non-default locations
  898. are used. (#4483)
  899. - Display a message to run the right command for modifying pip on Windows
  900. (#4490)
  901. - Add Man Pages for pip (#4491)
  902. - Make uninstall command less verbose by default (#4493)
  903. - Switch the default upgrade strategy to be 'only-if-needed' (#4500)
  904. - Installing from a local directory or a VCS URL now builds a wheel to install,
  905. rather than running ``setup.py install``. Wheels from these sources are not
  906. cached. (#4501)
  907. - Don't log a warning when installing a dependency from Git if the name looks
  908. like a commit hash. (#4507)
  909. - pip now displays a warning when it installs scripts from a wheel outside the
  910. PATH. These warnings can be suppressed using a new --no-warn-script-location
  911. option. (#4553)
  912. - Local Packages can now be referenced using forward slashes on Windows.
  913. (#4563)
  914. - pip show learnt a new Required-by field that lists currently installed
  915. packages that depend on the shown package (#4564)
  916. - The command-line autocompletion engine ``pip show`` now autocompletes
  917. installed distribution names. (#4749)
  918. - Change documentation theme to be in line with Python Documentation (#4758)
  919. - Add auto completion of short options. (#4954)
  920. - Run 'setup.py develop' inside pep518 build environment. (#4999)
  921. - pip install now prints an error message when it installs an incompatible
  922. version of a dependency. (#5000)
  923. - Added a way to distinguish between pip installed packages and those from the
  924. system package manager in 'pip list'. Specifically, 'pip list -v' also shows
  925. the installer of package if it has that meta data. (#949)
  926. - Show install locations when list command ran with "-v" option. (#979)
  927. Bug Fixes
  928. ---------
  929. - Allow pip to work if the ``GIT_DIR`` and ``GIT_WORK_TREE`` environment
  930. variables are set. (#1130)
  931. - Make ``pip install --force-reinstall`` not require passing ``--upgrade``.
  932. (#1139)
  933. - Return a failing exit status when `pip install`, `pip download`, or `pip
  934. wheel` is called with no requirements. (#2720)
  935. - Interactive setup.py files will no longer hang indefinitely. (#2732, #4982)
  936. - Correctly reset the terminal if an exception occurs while a progress bar is
  937. being shown. (#3015)
  938. - "Support URL-encoded characters in URL credentials." (#3236)
  939. - Don't assume sys.__stderr__.encoding exists (#3356)
  940. - Fix ``pip uninstall`` when ``easy-install.pth`` lacks a trailing newline.
  941. (#3741)
  942. - Keep install options in requirements.txt from leaking. (#3763)
  943. - pip no longer passes global options from one package to later packages in the
  944. same requirement file. (#3830)
  945. - Support installing from Git refs (#3876)
  946. - Use pkg_resources to parse the entry points file to allow names with colons.
  947. (#3901)
  948. - ``-q`` specified once correctly sets logging level to WARNING, instead of
  949. CRITICAL. Use `-qqq` to have the previous behavior back. (#3994)
  950. - Shell completion scripts now use correct executable names (e.g., ``pip3``
  951. instead of ``pip``) (#3997)
  952. - Changed vendored encodings from ``utf8`` to ``utf-8``. (#4076)
  953. - Fixes destination directory of data_files when ``pip install --target`` is
  954. used. (#4092)
  955. - Limit the disabling of requests' pyopenssl to Windows only. Fixes
  956. "SNIMissingWarning / InsecurePlatformWarning not fixable with pip 9.0 /
  957. 9.0.1" (for non-Windows) (#4098)
  958. - Support the installation of wheels with non-PEP 440 version in their
  959. filenames. (#4169)
  960. - Fall back to sys.getdefaultencoding() if locale.getpreferredencoding()
  961. returns None in `pip.utils.encoding.auto_decode`. (#4184)
  962. - Fix a bug where `SETUPTOOLS_SHIM` got called incorrectly for relative path
  963. requirements by converting relative paths to absolute paths prior to calling
  964. the shim. (#4208)
  965. - Return the latest version number in search results. (#4219)
  966. - Improve error message on permission errors (#4233)
  967. - Fail gracefully when ``/etc/image_version`` (or another distro version file)
  968. appears to exists but is not readable. (#4249)
  969. - Avoid importing setuptools in the parent pip process, to avoid a race
  970. condition when upgrading one of setuptools dependencies. (#4264)
  971. - Fix for an incorrect ``freeze`` warning message due to a package being
  972. included in multiple requirements files that were passed to ``freeze``.
  973. Instead of warning incorrectly that the package is not installed, pip now
  974. warns that the package was declared multiple times and lists the name of each
  975. requirements file that contains the package in question. (#4293)
  976. - Generalize help text for ``compile``/``no-compile`` flags. (#4316)
  977. - Handle the case when ``/etc`` is not readable by the current user by using a
  978. hardcoded list of possible names of release files. (#4320)
  979. - Fixed a ``NameError`` when attempting to catch ``FileNotFoundError`` on
  980. Python 2.7. (#4322)
  981. - Ensure USER_SITE is correctly initialised. (#4437)
  982. - Reinstalling an editable package from Git no longer assumes that the
  983. ``master`` branch exists. (#4448)
  984. - This fixes an issue where when someone who tries to use git with pip but pip
  985. can't because git is not in the path environment variable. This clarifies the
  986. error given to suggest to the user what might be wrong. (#4461)
  987. - Improve handling of text output from build tools (avoid Unicode errors)
  988. (#4486)
  989. - Fix a "No such file or directory" error when using --prefix. (#4495)
  990. - Allow commands to opt out of --require-venv. This allows pip help to work
  991. even when the environment variable PIP_REQUIRE_VIRTUALENV is set. (#4496)
  992. - Fix warning message on mismatched versions during installation. (#4655)
  993. - pip now records installed files in a deterministic manner improving
  994. reproducibility. (#4667)
  995. - Fix an issue where ``pip install -e`` on a Git url would fail to update if a
  996. branch or tag name is specified that happens to match the prefix of the
  997. current ``HEAD`` commit hash. (#4675)
  998. - Fix an issue where a variable assigned in a try clause was accessed in the
  999. except clause, resulting in an undefined variable error in the except clause.
  1000. (#4811)
  1001. - Use log level `info` instead of `warning` when ignoring packages due to
  1002. environment markers. (#4876)
  1003. - Replaced typo mistake in subversion support. (#4908)
  1004. - Terminal size is now correctly inferred when using Python 3 on Windows.
  1005. (#4966)
  1006. - Abort if reading configuration causes encoding errors. (#4976)
  1007. - Add a ``--no-user`` option and use it when installing build dependencies.
  1008. (#5085)
  1009. Vendored Libraries
  1010. ------------------
  1011. - Upgraded appdirs to 1.4.3.
  1012. - Upgraded CacheControl to 0.12.3.
  1013. - Vendored certifi at 2017.7.27.1.
  1014. - Vendored chardet at 3.0.4.
  1015. - Upgraded colorama to 0.3.9.
  1016. - Upgraded distlib to 0.2.6.
  1017. - Upgraded distro to 1.2.0.
  1018. - Vendored idna at idna==2.6.
  1019. - Upgraded ipaddress to 1.0.18.
  1020. - Vendored msgpack-python at 0.4.8.
  1021. - Removed the vendored ordereddict.
  1022. - Upgraded progress to 1.3.
  1023. - Upgraded pyparsing to 2.2.0.
  1024. - Upgraded pytoml to 0.1.14.
  1025. - Upgraded requests to 2.18.4.
  1026. - Upgraded pkg_resources (via setuptools) to 36.6.0.
  1027. - Upgraded six to 1.11.0.
  1028. - Vendored urllib3 at 1.22.
  1029. - Upgraded webencodings to 0.5.1.
  1030. Improved Documentation
  1031. ----------------------
  1032. - Added documentation on usage of --build command line option (#4262)
  1033. - (#4358)
  1034. - Document how to call pip from your code, including the fact that we do not
  1035. provide a Python API. (#4743)
  1036. 9.0.3 (2018-03-21)
  1037. ==================
  1038. - Fix an error where the vendored requests was not correctly containing itself
  1039. to only the internal vendored prefix.
  1040. - Restore compatibility with 2.6.
  1041. 9.0.2 (2018-03-16)
  1042. ==================
  1043. - Fallback to using SecureTransport on macOS when the linked OpenSSL is too old
  1044. to support TLSv1.2.
  1045. 9.0.1 (2016-11-06)
  1046. ==================
  1047. - Correct the deprecation message when not specifying a --format so that it
  1048. uses the correct setting name (``format``) rather than the incorrect one
  1049. (``list_format``). (#4058)
  1050. - Fix ``pip check`` to check all available distributions and not just the
  1051. local ones. (#4083)
  1052. - Fix a crash on non ASCII characters from `lsb_release`. (#4062)
  1053. - Fix an SyntaxError in an unused module of a vendored dependency. (#4059)
  1054. - Fix UNC paths on Windows. (#4064)
  1055. 9.0.0 (2016-11-02)
  1056. ==================
  1057. - **BACKWARD INCOMPATIBLE** Remove the attempted autodetection of requirement
  1058. names from URLs, URLs must include a name via ``#egg=``.
  1059. - **DEPRECATION** ``pip install --egg`` have been deprecated and will be
  1060. removed in the future. This "feature" has a long list of drawbacks which
  1061. break nearly all of pip's other features in subtle and hard-to-diagnose
  1062. ways.
  1063. - **DEPRECATION** ``--default-vcs`` option. (#4052)
  1064. - **WARNING** pip 9 cache can break forward compatibility with previous pip
  1065. versions if your package repository allows chunked responses. (#4078)
  1066. - Add an ``--upgrade-strategy`` option to ``pip install``, to control how
  1067. dependency upgrades are managed. (#3972)
  1068. - Add a ``pip check`` command to check installed packages dependencies. (#3750)
  1069. - Add option allowing user to abort pip operation if file/directory exists
  1070. - Add Appveyor CI
  1071. - Uninstall existing packages when performing an editable installation of
  1072. the same packages. (#1548)
  1073. - ``pip show`` is less verbose by default. ``--verbose`` prints multiline
  1074. fields. (#3858)
  1075. - Add optional column formatting to ``pip list``. (#3651)
  1076. - Add ``--not-required`` option to ``pip list``, which lists packages that are
  1077. not dependencies of other packages.
  1078. - Fix builds on systems with symlinked ``/tmp`` directory for custom
  1079. builds such as numpy. (#3701)
  1080. - Fix regression in ``pip freeze``: when there is more than one git remote,
  1081. priority is given to the remote named ``origin``. (#3708, #3616).
  1082. - Fix crash when calling ``pip freeze`` with invalid requirement installed.
  1083. (#3704, #3681)
  1084. - Allow multiple ``--requirement`` files in ``pip freeze``. (#3703)
  1085. - Implementation of pep-503 ``data-requires-python``. When this field is
  1086. present for a release link, pip will ignore the download when
  1087. installing to a Python version that doesn't satisfy the requirement.
  1088. - ``pip wheel`` now works on editable packages too (it was only working on
  1089. editable dependencies before); this allows running ``pip wheel`` on the result
  1090. of ``pip freeze`` in presence of editable requirements. (#3695, #3291)
  1091. - Load credentials from ``.netrc`` files. (#3715, #3569)
  1092. - Add ``--platform``, ``--python-version``, ``--implementation`` and ``--abi``
  1093. parameters to ``pip download``. These allow utilities and advanced users to
  1094. gather distributions for interpreters other than the one pip is being run on.
  1095. (#3760)
  1096. - Skip scanning virtual environments, even when venv/bin/python is a dangling
  1097. symlink.
  1098. - Added ``pip completion`` support for the ``fish`` shell.
  1099. - Fix problems on Windows on Python 2 when username or hostname contains
  1100. non-ASCII characters. (#3463, #3970, #4000)
  1101. - Use ``git fetch --tags`` to fetch tags in addition to everything else that
  1102. is normally fetched; this is necessary in case a git requirement url
  1103. points to a tag or commit that is not on a branch. (#3791)
  1104. - Normalize package names before using in ``pip show`` (#3976)
  1105. - Raise when Requires-Python do not match the running version and add
  1106. ``--ignore-requires-python`` option as escape hatch. (#3846)
  1107. - Report the correct installed version when performing an upgrade in some
  1108. corner cases. (#2382
  1109. - Add ``-i`` shorthand for ``--index`` flag in ``pip search``.
  1110. - Do not optionally load C dependencies in requests. (#1840, #2930, #3024)
  1111. - Strip authentication from SVN url prior to passing it to ``svn``.
  1112. (#3697, #3209)
  1113. - Also install in platlib with ``--target`` option. (#3694, #3682)
  1114. - Restore the ability to use inline comments in requirements files passed to
  1115. ``pip freeze``. (#3680)
  1116. 8.1.2 (2016-05-10)
  1117. ==================
  1118. - Fix a regression on systems with uninitialized locale. (#3575)
  1119. - Use environment markers to filter packages before determining if a required
  1120. wheel is supported. (#3254)
  1121. - Make glibc parsing for `manylinux1` support more robust for the variety of
  1122. glibc versions found in the wild. (#3588)
  1123. - Update environment marker support to fully support legacy and PEP 508 style
  1124. environment markers. (#3624)
  1125. - Always use debug logging to the ``--log`` file. (#3351)
  1126. - Don't attempt to wrap search results for extremely narrow terminal windows.
  1127. (#3655)
  1128. 8.1.1 (2016-03-17)
  1129. ==================
  1130. - Fix regression with non-ascii requirement files on Python 2 and add support
  1131. for encoding headers in requirement files. (#3548, #3547)
  1132. 8.1.0 (2016-03-05)
  1133. ==================
  1134. - Implement PEP 513, which adds support for the manylinux1 platform tag,
  1135. allowing carefully compiled binary wheels to be installed on compatible Linux
  1136. platforms.
  1137. - Allow wheels which are not specific to a particular Python interpreter but
  1138. which are specific to a particular platform. (#3202)
  1139. - Fixed an issue where ``call_subprocess`` would crash trying to print debug
  1140. data on child process failure. (#3521, #3522)
  1141. - Exclude the wheel package from the `pip freeze` output (like pip and
  1142. setuptools). (#2989)
  1143. - Allow installing modules from a subdirectory of a vcs repository in
  1144. non-editable mode. (#3217, #3466)
  1145. - Make pip wheel and pip download work with vcs urls with subdirectory option.
  1146. (#3466)
  1147. - Show classifiers in ``pip show``.
  1148. - Show PEP376 Installer in ``pip show``. (#3517)
  1149. - Unhide completion command. (#1810)
  1150. - Show latest version number in ``pip search`` results. (#1415)
  1151. - Decode requirement files according to their BOM if present. (#3485, #2865)
  1152. - Fix and deprecate package name detection from url path. (#3523, #3495)
  1153. - Correct the behavior where interpreter specific tags (such as cp34) were
  1154. being used on later versions of the same interpreter instead of only for that
  1155. specific interpreter. (#3472)
  1156. - Fix an issue where pip would erroneously install a 64 bit wheel on a 32 bit
  1157. Python running on a 64 bit macOS machine.
  1158. - Do not assume that all git repositories have an origin remote.
  1159. - Correctly display the line to add to a requirements.txt for an URL based
  1160. dependency when ``--require-hashes`` is enabled.
  1161. 8.0.3 (2016-02-25)
  1162. ==================
  1163. - Make ``install --quiet`` really quiet. (#3418)
  1164. - Fix a bug when removing packages in python 3: disable INI-style parsing of the
  1165. entry_point.txt file to allow entry point names with colons. (#3434)
  1166. - Normalize generated script files path in RECORD files. (#3448)
  1167. - Fix bug introduced in 8.0.0 where subcommand output was not shown,
  1168. even when the user specified ``-v`` / ``--verbose``. (#3486)
  1169. - Enable python -W with respect to PipDeprecationWarning. (#3455)
  1170. - Upgrade distlib to 0.2.2.
  1171. - Improved support for Jython when quoting executables in output scripts.
  1172. (#3467)
  1173. - Add a `--all` option to `pip freeze` to include usually skipped package
  1174. (like pip, setuptools and wheel) to the freeze output. (#1610)
  1175. 8.0.2 (2016-01-21)
  1176. ==================
  1177. - Stop attempting to trust the system CA trust store because it's extremely
  1178. common for them to be broken, often in incompatible ways. (#3416)
  1179. 8.0.1 (2016-01-21)
  1180. ==================
  1181. - Detect CAPaths in addition to CAFiles on platforms that provide them.
  1182. - Installing argparse or wsgiref will no longer warn or error - pip will allow
  1183. the installation even though it may be useless (since the installed thing
  1184. will be shadowed by the standard library).
  1185. - Upgrading a distutils installed item that is installed outside of a virtual
  1186. environment, while inside of a virtual environment will no longer warn or
  1187. error.
  1188. - Fix a bug where pre-releases were showing up in ``pip list --outdated``
  1189. without the ``--pre`` flag.
  1190. - Switch the SOABI emulation from using RuntimeWarnings to debug logging.
  1191. - Rollback the removal of the ability to uninstall distutils installed items
  1192. until a future date.
  1193. 8.0.0 (2016-01-19)
  1194. ==================
  1195. - **BACKWARD INCOMPATIBLE** Drop support for Python 3.2.
  1196. - **BACKWARD INCOMPATIBLE** Remove the ability to find any files other than the
  1197. ones directly linked from the index or find-links pages.
  1198. - **BACKWARD INCOMPATIBLE** Remove the ``--download-cache`` which had been
  1199. deprecated and no-op'd in 6.0.
  1200. - **BACKWARD INCOMPATIBLE** Remove the ``--log-explicit-levels`` which had been
  1201. deprecated in 6.0.
  1202. - **BACKWARD INCOMPATIBLE** Change pip wheel --wheel-dir default path from
  1203. <cwd>/wheelhouse to <cwd>.
  1204. - Deprecate and no-op the ``--allow-external``, ``--allow-all-external``, and
  1205. ``--allow-unverified`` functionality that was added as part of PEP 438. With
  1206. changes made to the repository protocol made in PEP 470, these options are no
  1207. longer functional.
  1208. - Allow ``--trusted-host`` within a requirements file. (#2822)
  1209. - Allow ``--process-dependency-links`` within a requirements file. (#1274)
  1210. - Allow ``--pre`` within a requirements file. (#1273)
  1211. - Allow repository URLs with secure transports to count as trusted. (E.g.,
  1212. "git+ssh" is okay.) (#2811)
  1213. - Implement a top-level ``pip download`` command and deprecate
  1214. ``pip install --download``.
  1215. - When uninstalling, look for the case of paths containing symlinked
  1216. directories (#3141, #3154)
  1217. - When installing, if building a wheel fails, clear up the build directory
  1218. before falling back to a source install. (#3047)
  1219. - Fix user directory expansion when ``HOME=/``. Workaround for Python bug
  1220. https://bugs.python.org/issue14768. (#2996)
  1221. - Correct reporting of requirements file line numbers. (#3009, #3125)
  1222. - Fixed Exception(IOError) for ``pip freeze`` and ``pip list`` commands with
  1223. subversion >= 1.7. (#1062, #3346)
  1224. - Provide a spinner showing that progress is happening when installing or
  1225. building a package via ``setup.py``. This will alleviate concerns that
  1226. projects with unusually long build times have with pip appearing to stall.
  1227. - Include the functionality of ``peep`` into pip, allowing hashes to be baked
  1228. into a requirements file and ensuring that the packages being downloaded
  1229. match one of those hashes. This is an additional, opt-in security measure
  1230. that, when used, removes the need to trust the repository.
  1231. - Fix a bug causing pip to not select a wheel compiled against an OSX SDK later
  1232. than what Python itself was compiled against when running on a newer version
  1233. of OSX.
  1234. - Add a new ``--prefix`` option for ``pip install`` that supports wheels and
  1235. sdists. (#3252)
  1236. - Fixed issue regarding wheel building with setup.py using a different encoding
  1237. than the system. (#2042)
  1238. - Drop PasteScript specific egg_info hack. (#3270)
  1239. - Allow combination of pip list options --editable with --outdated/--uptodate.
  1240. (#933)
  1241. - Gives VCS implementations control over saying whether a project is under
  1242. their control. (#3258)
  1243. - Git detection now works when ``setup.py`` is not at the Git repo root
  1244. and when ``package_dir`` is used, so ``pip freeze`` works in more
  1245. cases. (#3258)
  1246. - Correctly freeze Git develop packages in presence of the &subdirectory
  1247. option (#3258)
  1248. - The detection of editable packages now relies on the presence of ``.egg-link``
  1249. instead of looking for a VCS, so ``pip list -e`` is more reliable. (#3258)
  1250. - Add the ``--prefix`` flag to ``pip install`` which allows specifying a root
  1251. prefix to use instead of ``sys.prefix``. (#3252)
  1252. - Allow duplicate specifications in the case that only the extras differ, and
  1253. union all specified extras together. (#3198)
  1254. - Fix the detection of the user's current platform on OSX when determining the
  1255. OSX SDK version. (#3232)
  1256. - Prevent the automatically built wheels from mistakenly being used across
  1257. multiple versions of Python when they may not be correctly configured for
  1258. that by making the wheel specific to a specific version of Python and
  1259. specific interpreter. (#3225)
  1260. - Emulate the SOABI support in wheels from Python 2.x on Python 2.x as closely
  1261. as we can with the information available within the interpreter. (#3075)
  1262. - Don't roundtrip to the network when git is pinned to a specific commit hash
  1263. and that hash already exists locally. (#3066)
  1264. - Prefer wheels built against a newer SDK to wheels built against an older SDK
  1265. on OSX. (#3163)
  1266. - Show entry points for projects installed via wheel. (#3122)
  1267. - Improve message when an unexisting path is passed to --find-links option.
  1268. (#2968)
  1269. - pip freeze does not add the VCS branch/tag name in the #egg=... fragment
  1270. anymore. (#3312)
  1271. - Warn on installation of editable if the provided #egg=name part does not
  1272. match the metadata produced by `setup.py egg_info`. (#3143)
  1273. - Add support for .xz files for python versions supporting them (>= 3.3). (#722)
  1274. 7.1.2 (2015-08-22)
  1275. ==================
  1276. - Don't raise an error if pip is not installed when checking for the latest pip
  1277. version.
  1278. 7.1.1 (2015-08-20)
  1279. ==================
  1280. - Check that the wheel cache directory is writable before we attempt to write
  1281. cached files to them.
  1282. - Move the pip version check until *after* any installs have been performed,
  1283. thus removing the extraneous warning when upgrading pip.
  1284. - Added debug logging when using a cached wheel.
  1285. - Respect platlib by default on platforms that have it separated from purelib.
  1286. - Upgrade packaging to 15.3.
  1287. - Normalize post-release spellings for rev/r prefixes.
  1288. - Upgrade distlib to 0.2.1.
  1289. - Updated launchers to decode shebangs using UTF-8. This allows non-ASCII
  1290. pathnames to be correctly handled.
  1291. - Ensured that the executable written to shebangs is normcased.
  1292. - Changed ScriptMaker to work better under Jython.
  1293. - Upgrade ipaddress to 1.0.13.
  1294. 7.1.0 (2015-06-30)
  1295. ==================
  1296. - Allow constraining versions globally without having to know exactly what will
  1297. be installed by the pip command. (#2731)
  1298. - Accept --no-binary and --only-binary via pip.conf. (#2867)
  1299. - Allow ``--allow-all-external`` within a requirements file.
  1300. - Fixed an issue where ``--user`` could not be used when ``--prefix`` was used
  1301. in a distutils configuration file.
  1302. - Fixed an issue where the SOABI tags were not correctly being generated on
  1303. Python 3.5.
  1304. - Fixed an issue where we were advising windows users to upgrade by directly
  1305. executing pip, when that would always fail on Windows.
  1306. - Allow ``~`` to be expanded within a cache directory in all situations.
  1307. 7.0.3 (2015-06-01)
  1308. ==================
  1309. - Fixed a regression where ``--no-cache-dir`` would raise an exception. (#2855)
  1310. 7.0.2 (2015-06-01)
  1311. ==================
  1312. - **BACKWARD INCOMPATIBLE** Revert the change (released in v7.0.0) that
  1313. required quoting in requirements files around specifiers containing
  1314. environment markers. (#2841)
  1315. - **BACKWARD INCOMPATIBLE** Revert the accidental introduction of support for
  1316. options interleaved with requirements, version specifiers etc in
  1317. ``requirements`` files. (#2841)
  1318. - Expand ``~`` in the cache directory when caching wheels. (#2816)
  1319. - Use ``python -m pip`` instead of ``pip`` when recommending an upgrade command
  1320. to Windows users.
  1321. 7.0.1 (2015-05-22)
  1322. ==================
  1323. - Don't build and cache wheels for non-editable installations from VCSs.
  1324. - Allow ``--allow-all-external`` inside of a requirements.txt file, fixing a
  1325. regression in 7.0.
  1326. 7.0.0 (2015-05-21)
  1327. ==================
  1328. - **BACKWARD INCOMPATIBLE** Removed the deprecated ``--mirror``,
  1329. ``--use-mirrors``, and ``-M`` options.
  1330. - **BACKWARD INCOMPATIBLE** Removed the deprecated ``zip`` and ``unzip``
  1331. commands.
  1332. - **BACKWARD INCOMPATIBLE** Removed the deprecated ``--no-install`` and
  1333. ``--no-download`` options.
  1334. - **BACKWARD INCOMPATIBLE** No longer implicitly support an insecure origin
  1335. origin, and instead require insecure origins be explicitly trusted with the
  1336. ``--trusted-host`` option.
  1337. - **BACKWARD INCOMPATIBLE** Removed the deprecated link scraping that attempted
  1338. to parse HTML comments for a specially formatted comment.
  1339. - **BACKWARD INCOMPATIBLE** Requirements in requirements files containing
  1340. markers must now be quoted due to parser changes. For example, use
  1341. ``"SomeProject; python_version < '2.7'"``, not simply
  1342. ``SomeProject; python_version < '2.7'`` (#2697, #2725)
  1343. - `get-pip.py` now installs the "wheel" package, when it's not already
  1344. installed. (#2800)
  1345. - Ignores bz2 archives if Python wasn't compiled with bz2 support. (#497)
  1346. - Support ``--install-option`` and ``--global-option`` per requirement in
  1347. requirement files. (#2537)
  1348. - Build Wheels prior to installing from sdist, caching them in the pip cache
  1349. directory to speed up subsequent installs. (#2618)
  1350. - Allow fine grained control over the use of wheels and source builds. (#2699)
  1351. - ``--no-use-wheel`` and ``--use-wheel`` are deprecated in favour of new
  1352. options ``--no-binary`` and ``--only-binary``. The equivalent of
  1353. ``--no-use-wheel`` is ``--no-binary=:all:``. (#2699)
  1354. - The use of ``--install-option``, ``--global-option`` or ``--build-option``
  1355. disable the use of wheels, and the autobuilding of wheels. (#2711, #2677)
  1356. - Improve logging when a requirement marker doesn't match your environment.
  1357. (#2735)
  1358. - Removed the temporary modifications (that began in pip v1.4 when distribute
  1359. and setuptools merged) that allowed distribute to be considered a conflict to
  1360. setuptools. ``pip install -U setuptools`` will no longer upgrade "distribute"
  1361. to "setuptools". Instead, use ``pip install -U distribute``. (#2767)
  1362. - Only display a warning to upgrade pip when the newest version is a final
  1363. release and it is not a post release of the version we already have
  1364. installed. (#2766)
  1365. - Display a warning when attempting to access a repository that uses HTTPS when
  1366. we don't have Python compiled with SSL support. (#2761)
  1367. - Allowing using extras when installing from a file path without requiring the
  1368. use of an editable. (#2785)
  1369. - Fix an infinite loop when the cache directory is stored on a file system
  1370. which does not support hard links. (#2796)
  1371. - Remove the implicit debug log that was written on every invocation, instead
  1372. users will need to use ``--log`` if they wish to have one. (#2798)
  1373. 6.1.1 (2015-04-07)
  1374. ==================
  1375. - No longer ignore dependencies which have been added to the standard library,
  1376. instead continue to install them.
  1377. 6.1.0 (2015-04-07)
  1378. ==================
  1379. - Fixes upgrades failing when no potential links were found for dependencies
  1380. other than the current installation. (#2538, #2502)
  1381. - Use a smoother progress bar when the terminal is capable of handling it,
  1382. otherwise fallback to the original ASCII based progress bar.
  1383. - Display much less output when `pip install` succeeds, because on success,
  1384. users probably don't care about all the nitty gritty details of compiling and
  1385. installing. When `pip install` fails, display the failed install output once
  1386. instead of twice, because once is enough. (#2487)
  1387. - Upgrade the bundled copy of requests to 2.6.0, fixing CVE-2015-2296.
  1388. - Display format of latest package when using ``pip list --outdated``. (#2475)
  1389. - Don't use pywin32 as ctypes should always be available on Windows, using
  1390. pywin32 prevented uninstallation of pywin32 on Windows. (:pull:`2467`)
  1391. - Normalize the ``--wheel-dir`` option, expanding out constructs such as ``~``
  1392. when used. (#2441)
  1393. - Display a warning when an undefined extra has been requested. (#2142)
  1394. - Speed up installing a directory in certain cases by creating a sdist instead
  1395. of copying the entire directory. (#2535)
  1396. - Don't follow symlinks when uninstalling files (#2552)
  1397. - Upgrade the bundled copy of cachecontrol from 0.11.1 to 0.11.2. (#2481, #2595)
  1398. - Attempt to more smartly choose the order of installation to try and install
  1399. dependencies before the projects that depend on them. (#2616)
  1400. - Skip trying to install libraries which are part of the standard library.
  1401. (#2636, #2602)
  1402. - Support arch specific wheels that are not tied to a specific Python ABI.
  1403. (#2561)
  1404. - Output warnings and errors to stderr instead of stdout. (#2543)
  1405. - Adjust the cache dir file checks to only check ownership if the effective
  1406. user is root. (#2396)
  1407. - Install headers into a per project name directory instead of all of them into
  1408. the root directory when inside of a virtual environment. (#2421)
  1409. 6.0.8 (2015-02-04)
  1410. ==================
  1411. - Fix an issue where the ``--download`` flag would cause pip to no longer use
  1412. randomized build directories.
  1413. - Fix an issue where pip did not properly unquote quoted URLs which contain
  1414. characters like PEP 440's epoch separator (``!``).
  1415. - Fix an issue where distutils installed projects were not actually uninstalled
  1416. and deprecate attempting to uninstall them altogether.
  1417. - Retry deleting directories in case a process like an antivirus is holding the
  1418. directory open temporarily.
  1419. - Fix an issue where pip would hide the cursor on Windows but would not reshow
  1420. it.
  1421. 6.0.7 (2015-01-28)
  1422. ==================
  1423. - Fix a regression where Numpy requires a build path without symlinks to
  1424. properly build.
  1425. - Fix a broken log message when running ``pip wheel`` without a requirement.
  1426. - Don't mask network errors while downloading the file as a hash failure.
  1427. - Properly create the state file for the pip version check so it only happens
  1428. once a week.
  1429. - Fix an issue where switching between Python 3 and Python 2 would evict cached
  1430. items.
  1431. - Fix a regression where pip would be unable to successfully uninstall a
  1432. project without a normalized version.
  1433. 6.0.6 (2015-01-03)
  1434. ==================
  1435. - Continue the regression fix from 6.0.5 which was not a complete fix.
  1436. 6.0.5 (2015-01-03)
  1437. ==================
  1438. - Fix a regression with 6.0.4 under Windows where most commands would raise an
  1439. exception due to Windows not having the ``os.geteuid()`` function.
  1440. 6.0.4 (2015-01-03)
  1441. ==================
  1442. - Fix an issue where ANSI escape codes would be used on Windows even though the
  1443. Windows shell does not support them, causing odd characters to appear with
  1444. the progress bar.
  1445. - Fix an issue where using -v would cause an exception saying
  1446. ``TypeError: not all arguments converted during string formatting``.
  1447. - Fix an issue where using -v with dependency links would cause an exception
  1448. saying ``TypeError: 'InstallationCandidate' object is not iterable``.
  1449. - Fix an issue where upgrading distribute would cause an exception saying
  1450. ``TypeError: expected string or buffer``.
  1451. - Show a warning and disable the use of the cache directory when the cache
  1452. directory is not owned by the current user, commonly caused by using ``sudo``
  1453. without the ``-H`` flag.
  1454. - Update PEP 440 support to handle the latest changes to PEP 440, particularly
  1455. the changes to ``>V`` and ``<V`` so that they no longer imply ``!=V.*``.
  1456. - Document the default cache directories for each operating system.
  1457. - Create the cache directory when the pip version check needs to save to it
  1458. instead of silently logging an error.
  1459. - Fix a regression where the ``-q`` flag would not properly suppress the
  1460. display of the progress bars.
  1461. 6.0.3 (2014-12-23)
  1462. ==================
  1463. - Fix an issue where the implicit version check new in pip 6.0 could cause pip
  1464. to block for up to 75 seconds if PyPI was not accessible.
  1465. - Make ``--no-index`` imply ``--disable-pip-version-check``.
  1466. 6.0.2 (2014-12-23)
  1467. ==================
  1468. - Fix an issue where the output saying that a package was installed would
  1469. report the old version instead of the new version during an upgrade.
  1470. - Fix left over merge conflict markers in the documentation.
  1471. - Document the backwards incompatible PEP 440 change in the 6.0.0 changelog.
  1472. 6.0.1 (2014-12-22)
  1473. ==================
  1474. - Fix executable file permissions for Wheel files when using the distutils
  1475. scripts option.
  1476. - Fix a confusing error message when an exceptions was raised at certain
  1477. points in pip's execution.
  1478. - Fix the missing list of versions when a version cannot be found that matches
  1479. the specifiers.
  1480. - Add a warning about the possibly problematic use of > when the given
  1481. specifier doesn't match anything.
  1482. - Fix an issue where installing from a directory would not copy over certain
  1483. directories which were being excluded, however some build systems rely on
  1484. them.
  1485. 6.0 (2014-12-22)
  1486. ================
  1487. - **PROCESS** Version numbers are now simply ``X.Y`` where the leading ``1``
  1488. has been dropped.
  1489. - **BACKWARD INCOMPATIBLE** Dropped support for Python 3.1.
  1490. - **BACKWARD INCOMPATIBLE** Removed the bundle support which was deprecated in
  1491. 1.4. (#1806)
  1492. - **BACKWARD INCOMPATIBLE** File lists generated by `pip show -f` are now
  1493. rooted at the location reported by show, rather than one (unstated)
  1494. directory lower. (#1933)
  1495. - **BACKWARD INCOMPATIBLE** The ability to install files over the FTP protocol
  1496. was accidentally lost in pip 1.5 and it has now been decided to not restore
  1497. that ability.
  1498. - **BACKWARD INCOMPATIBLE** PEP 440 is now fully implemented, this means that
  1499. in some cases versions will sort differently or version specifiers will be
  1500. interpreted differently than previously. The common cases should all function
  1501. similarly to before.
  1502. - **DEPRECATION** ``pip install --download-cache`` and
  1503. ``pip wheel --download-cache`` command line flags have been deprecated and
  1504. the functionality removed. Since pip now automatically configures and uses
  1505. it's internal HTTP cache which supplants the ``--download-cache`` the
  1506. existing options have been made non functional but will still be accepted
  1507. until their removal in pip v8.0. For more information please see
  1508. https://pip.pypa.io/en/stable/reference/pip_install.html#caching
  1509. - **DEPRECATION** ``pip install --build`` and ``pip install --no-clean`` are now
  1510. *NOT* deprecated. This reverses the deprecation that occurred in v1.5.3.
  1511. (#906)
  1512. - **DEPRECATION** Implicitly accessing URLs which point to an origin which is
  1513. not a secure origin, instead requiring an opt-in for each host using the new
  1514. ``--trusted-host`` flag (``pip install --trusted-host example.com foo``).
  1515. - Allow the new ``--trusted-host`` flag to also disable TLS verification for
  1516. a particular hostname.
  1517. - Added a ``--user`` flag to ``pip freeze`` and ``pip list`` to check the
  1518. user site directory only.
  1519. - Silence byte compile errors when installation succeed. (#1873)
  1520. - Added a virtualenv-specific configuration file. (#1364)
  1521. - Added site-wide configuration files. (1978)
  1522. - Added an automatic check to warn if there is an updated version of pip
  1523. available. (#2049)
  1524. - `wsgiref` and `argparse` (for >py26) are now excluded from `pip list` and
  1525. `pip freeze`. (#1606, #1369)
  1526. - Add ``--client-cert`` option for SSL client certificates. (#1424)
  1527. - `pip show --files` was broken for wheel installs. (#1635, #1484)
  1528. - install_lib should take precedence when reading distutils config.
  1529. (#1642, #1641)
  1530. - Send `Accept-Encoding: identity` when downloading files in an attempt to
  1531. convince some servers who double compress the downloaded file to stop doing
  1532. so. (#1688)
  1533. - Stop breaking when given pip commands in uppercase (#1559, #1725)
  1534. - pip no longer adds duplicate logging consumers, so it won't create duplicate
  1535. output when being called multiple times. (#1618, #1723)
  1536. - `pip wheel` now returns an error code if any wheels fail to build. (#1769)
  1537. - `pip wheel` wasn't building wheels for dependencies of editable requirements.
  1538. (#1775)
  1539. - Allow the use of ``--no-use-wheel`` within a requirements file. (#1859)
  1540. - Attempt to locate system TLS certificates to use instead of the included
  1541. CA Bundle if possible. (#1680, #1866)
  1542. - Allow use of Zip64 extension in Wheels and other zip files. (#1319, #1868)
  1543. - Properly handle an index or --find-links target which has a <base> without a
  1544. href attribute. (#1101, #1869)
  1545. - Properly handle extras when a project is installed via Wheel. (#1885, #1896)
  1546. - Added support to respect proxies in ``pip search``.
  1547. (#1180, #932, #1104, #1902)
  1548. - `pip install --download` works with vcs links. (#798, #1060, #1926)
  1549. - Disabled warning about insecure index host when using localhost. Based off of
  1550. Guy Rozendorn's work in #1718. (#1456, #1967)
  1551. - Allow the use of OS standard user configuration files instead of ones simply
  1552. based around ``$HOME``. (#2021)
  1553. - When installing directly from wheel paths or urls, previous versions were not
  1554. uninstalled. (#1825, #804, #1838)
  1555. - Detect the location of the ``.egg-info`` directory by looking for any file
  1556. located inside of it instead of relying on the record file listing a
  1557. directory. (#2075, #2076)
  1558. - Use a randomized and secure default build directory when possible.
  1559. (#1964, #1935, #676, #2122, CVE-2014-8991)
  1560. - Support environment markers in requirements.txt files. (#1433, #2134)
  1561. - Automatically retry failed HTTP requests by default. (#1444, #2147)
  1562. - Handle HTML Encoding better using a method that is more similar to how
  1563. browsers handle it. (#1100, #1874)
  1564. - Reduce the verbosity of the pip command by default. (#2175, #2177, #2178)
  1565. - Fixed :issue:`2031` - Respect sys.executable on OSX when installing from
  1566. Wheels.
  1567. - Display the entire URL of the file that is being downloaded when downloading
  1568. from a non PyPI repository. (#2183)
  1569. - Support setuptools style environment markers in a source distribution. (#2153)
  1570. 1.5.6 (2014-05-16)
  1571. ==================
  1572. - Upgrade requests to 2.3.0 to fix an issue with proxies on Python 3.4.1.
  1573. (#1821)
  1574. 1.5.5 (2014-05-03)
  1575. ==================
  1576. - Uninstall issues on debianized pypy, specifically issues with setuptools
  1577. upgrades. (#1632, #1743)
  1578. - Update documentation to point at https://bootstrap.pypa.io/get-pip.py for
  1579. bootstrapping pip.
  1580. - Update docs to point to https://pip.pypa.io/
  1581. - Upgrade the bundled projects (distlib==0.1.8, html5lib==1.0b3, six==1.6.1,
  1582. colorama==0.3.1, setuptools==3.4.4).
  1583. 1.5.4 (2014-02-21)
  1584. ==================
  1585. - Correct deprecation warning for ``pip install --build`` to only notify when
  1586. the `--build` value is different than the default.
  1587. 1.5.3 (2014-02-20)
  1588. ==================
  1589. - **DEPRECATION** ``pip install --build`` and ``pip install --no-clean`` are now
  1590. deprecated. (#906)
  1591. - Fixed being unable to download directly from wheel paths/urls, and when wheel
  1592. downloads did occur using requirement specifiers, dependencies weren't
  1593. downloaded. (#1112, #1527)
  1594. - ``pip wheel`` was not downloading wheels that already existed. (#1320, #1524)
  1595. - ``pip install --download`` was failing using local ``--find-links``.
  1596. (#1111, #1524)
  1597. - Workaround for Python bug https://bugs.python.org/issue20053. (#1544)
  1598. - Don't pass a unicode __file__ to setup.py on Python 2.x. (#1583)
  1599. - Verify that the Wheel version is compatible with this pip. (#1569)
  1600. 1.5.2 (2014-01-26)
  1601. ==================
  1602. - Upgraded the vendored ``pkg_resources`` and ``_markerlib`` to setuptools 2.1.
  1603. - Fixed an error that prevented accessing PyPI when pyopenssl, ndg-httpsclient,
  1604. and pyasn1 are installed.
  1605. - Fixed an issue that caused trailing comments to be incorrectly included as
  1606. part of the URL in a requirements file.
  1607. 1.5.1 (2014-01-20)
  1608. ==================
  1609. - pip now only requires setuptools (any setuptools, not a certain version) when
  1610. installing distributions from src (i.e. not from wheel). (#1434)
  1611. - `get-pip.py` now installs setuptools, when it's not already installed. (#1475)
  1612. - Don't decode downloaded files that have a ``Content-Encoding`` header. (#1435)
  1613. - Fix to correctly parse wheel filenames with single digit versions. (#1445)
  1614. - If `--allow-unverified` is used assume it also means `--allow-external`.
  1615. (#1457)
  1616. 1.5 (2014-01-01)
  1617. ================
  1618. - **BACKWARD INCOMPATIBLE** pip no longer supports the ``--use-mirrors``,
  1619. ``-M``, and ``--mirrors`` flags. The mirroring support has been removed. In
  1620. order to use a mirror specify it as the primary index with ``-i`` or
  1621. ``--index-url``, or as an additional index with ``--extra-index-url``.
  1622. (#1098, CVE-2013-5123)
  1623. - **BACKWARD INCOMPATIBLE** pip no longer will scrape insecure external urls by
  1624. default nor will it install externally hosted files by default. Users may opt
  1625. into installing externally hosted or insecure files or urls using
  1626. ``--allow-external PROJECT`` and ``--allow-unverified PROJECT``. (#1055)
  1627. - **BACKWARD INCOMPATIBLE** pip no longer respects dependency links by default.
  1628. Users may opt into respecting them again using ``--process-dependency-links``.
  1629. - **DEPRECATION** ``pip install --no-install`` and ``pip install
  1630. --no-download`` are now formally deprecated. See #906 for discussion on
  1631. possible alternatives, or lack thereof, in future releases.
  1632. - **DEPRECATION** ``pip zip`` and ``pip unzip`` are now formally deprecated.
  1633. - pip will now install Mac OSX platform wheels from PyPI. (:pull:`1278`)
  1634. - pip now generates the appropriate platform-specific console scripts when
  1635. installing wheels. (#1251)
  1636. - pip now confirms a wheel is supported when installing directly from a path or
  1637. url. (#1315)
  1638. - ``--ignore-installed`` now behaves again as designed, after it was
  1639. unintentionally broke in v0.8.3 when fixing #14. (#1097, #1352)
  1640. - Fixed a bug where global scripts were being removed when uninstalling --user
  1641. installed packages. (#1353)
  1642. - ``--user`` wasn't being respected when installing scripts from wheels.
  1643. (#1163, #1176)
  1644. - Assume '_' means '-' in versions from wheel filenames. (#1150, #1158)
  1645. - Error when using --log with a failed install. (#219, #1205)
  1646. - Fixed logging being buffered and choppy in Python 3. (#1131)
  1647. - Don't ignore --timeout. (#70, #1202)
  1648. - Fixed an error when setting PIP_EXISTS_ACTION. (#772, #1201)
  1649. - Added colors to the logging output in order to draw attention to important
  1650. warnings and errors. (#1109)
  1651. - Added warnings when using an insecure index, find-link, or dependency link.
  1652. (#1121)
  1653. - Added support for installing packages from a subdirectory using the
  1654. ``subdirectory`` editable option. (#1082)
  1655. - Fixed "TypeError: bad operand type for unary" in some cases when installing
  1656. wheels using --find-links. (#1192, #1218)
  1657. - Archive contents are now written based on system defaults and umask (i.e.
  1658. permissions are not preserved), except that regular files with any execute
  1659. permissions have the equivalent of "chmod +x" applied after being written.
  1660. (#1133, #317, #1146)
  1661. - PreviousBuildDirError now returns a non-zero exit code and prevents the
  1662. previous build dir from being cleaned in all cases. (#1162)
  1663. - Renamed --allow-insecure to --allow-unverified, however the old name will
  1664. continue to work for a period of time. (#1257)
  1665. - Fixed an error when installing local projects with symlinks in Python 3.
  1666. (#1006, #1311)
  1667. - The previously hidden ``--log-file`` option, is now shown as a general option.
  1668. (#1316)
  1669. 1.4.1 (2013-08-07)
  1670. ==================
  1671. - **New Signing Key** Release 1.4.1 is using a different key than normal with
  1672. fingerprint: 7C6B 7C5D 5E2B 6356 A926 F04F 6E3C BCE9 3372 DCFA
  1673. - Fixed issues with installing from pybundle files. (#1116)
  1674. - Fixed error when sysconfig module throws an exception. (#1095)
  1675. - Don't ignore already installed pre-releases. (#1076)
  1676. - Fixes related to upgrading setuptools. (#1092)
  1677. - Fixes so that --download works with wheel archives. (#1113)
  1678. - Fixes related to recognizing and cleaning global build dirs. (#1080)
  1679. 1.4 (2013-07-23)
  1680. ================
  1681. - **BACKWARD INCOMPATIBLE** pip now only installs stable versions by default,
  1682. and offers a new ``--pre`` option to also find pre-release and development
  1683. versions. (#834)
  1684. - **BACKWARD INCOMPATIBLE** Dropped support for Python 2.5. The minimum
  1685. supported Python version for pip 1.4 is Python 2.6.
  1686. - Added support for installing and building wheel archives. Thanks Daniel Holth,
  1687. Marcus Smith, Paul Moore, and Michele Lacchia (#845)
  1688. - Applied security patch to pip's ssl support related to certificate DNS
  1689. wildcard matching (https://bugs.python.org/issue17980).
  1690. - To satisfy pip's setuptools requirement, pip now recommends setuptools>=0.8,
  1691. not distribute. setuptools and distribute are now merged into one project
  1692. called 'setuptools'. (#1003)
  1693. - pip will now warn when installing a file that is either hosted externally to
  1694. the index or cannot be verified with a hash. In the future pip will default
  1695. to not installing them and will require the flags --allow-external NAME, and
  1696. --allow-insecure NAME respectively. (#985)
  1697. - If an already-downloaded or cached file has a bad hash, re-download it rather
  1698. than erroring out. (#963)
  1699. - ``pip bundle`` and support for installing from pybundle files is now
  1700. considered deprecated and will be removed in pip v1.5.
  1701. - Fix a number of issues related to cleaning up and not reusing build
  1702. directories. (#413, #709, #634, #602, #939, #865, #948)
  1703. - Added a User Agent so that pip is identifiable in logs. (#901)
  1704. - Added ssl and --user support to get-pip.py. Thanks Gabriel de Perthuis.
  1705. (#895)
  1706. - Fixed the proxy support, which was broken in pip 1.3.x (#840)
  1707. - Fixed pip failing when server does not send content-type header. Thanks
  1708. Hugo Lopes Tavares and Kelsey Hightower. (#32, #872)
  1709. - "Vendorized" distlib as pip.vendor.distlib (https://distlib.readthedocs.io/).
  1710. - Fixed git VCS backend with git 1.8.3. (#967)
  1711. 1.3.1 (2013-03-08)
  1712. ==================
  1713. - Fixed a major backward incompatible change of parsing URLs to externally
  1714. hosted packages that got accidentally included in 1.3.
  1715. 1.3 (2013-03-07)
  1716. ================
  1717. - SSL Cert Verification; Make https the default for PyPI access. Thanks
  1718. James Cleveland, Giovanni Bajo, Marcus Smith and many others.
  1719. (#791, CVE-2013-1629)
  1720. - Added "pip list" for listing installed packages and the latest version
  1721. available. Thanks Rafael Caricio, Miguel Araujo, Dmitry Gladkov. (#752)
  1722. - Fixed security issues with pip's use of temp build directories.
  1723. Thanks David (d1b) and Thomas Guttler. (#780, CVE-2013-1888)
  1724. - Improvements to sphinx docs and cli help. (#773)
  1725. - Fixed an issue dealing with macOS temp dir handling, which was causing global
  1726. NumPy installs to fail. (#707, #768)
  1727. - Split help output into general vs command-specific option groups.
  1728. Thanks Georgi Valkov. (#744, #721)
  1729. - Fixed dependency resolution when installing from archives with uppercase
  1730. project names. (#724)
  1731. - Fixed problem where re-installs always occurred when using file:// find-links.
  1732. (#683, #702)
  1733. - "pip install -v" now shows the full download url, not just the archive name.
  1734. Thanks Marc Abramowitz (#687)
  1735. - Fix to prevent unnecessary PyPI redirects. Thanks Alex Gronholm (#695)
  1736. - Fixed an install failure under Python 3 when the same version of a package is
  1737. found under 2 different URLs. Thanks Paul Moore (#670, #671)
  1738. - Fix git submodule recursive updates. Thanks Roey Berman. (#674)
  1739. - Explicitly ignore rel='download' links while looking for html pages. Thanks
  1740. Maxime R. (#677)
  1741. - --user/--upgrade install options now work together. Thanks 'eevee' for
  1742. discovering the problem. (#705)
  1743. - Added check in ``install --download`` to prevent re-downloading if the target
  1744. file already exists. Thanks Andrey Bulgakov. (#669)
  1745. - Added support for bare paths (including relative paths) as argument to
  1746. `--find-links`. Thanks Paul Moore for draft patch.
  1747. - Added support for --no-index in requirements files.
  1748. - Added "pip show" command to get information about an installed package.
  1749. Thanks Kelsey Hightower and Rafael Caricio. (#131)
  1750. - Added `--root` option for "pip install" to specify root directory. Behaves
  1751. like the same option in distutils but also plays nice with pip's egg-info.
  1752. Thanks Przemek Wrzos. (#253, #693)
  1753. 1.2.1 (2012-09-06)
  1754. ==================
  1755. - Fixed a regression introduced in 1.2 about raising an exception when
  1756. not finding any files to uninstall in the current environment. Thanks for
  1757. the fix, Marcus Smith.
  1758. 1.2 (2012-09-01)
  1759. ================
  1760. - **Dropped support for Python 2.4** The minimum supported Python version is
  1761. now Python 2.5.
  1762. - Fixed PyPI mirror support being broken on some DNS responses. Thanks
  1763. philwhin. (#605)
  1764. - Fixed pip uninstall removing files it didn't install. Thanks pjdelport.
  1765. (#355)
  1766. - Fixed a number of issues related to improving support for the user
  1767. installation scheme. Thanks Marcus Smith. (#493, #494, #440, #573)
  1768. - Write failure log to temp file if default location is not writable. Thanks
  1769. andreigc.
  1770. - Pull in submodules for git editable checkouts. Thanks Hsiaoming Yang and
  1771. Markus Hametner. (#289, #421)
  1772. - Use a temporary directory as the default build location outside of a
  1773. virtualenv. Thanks Ben Rosser. (#339, #381)
  1774. - Added support for specifying extras with local editables. Thanks Nick
  1775. Stenning.
  1776. - Added ``--egg`` flag to request egg-style rather than flat installation.
  1777. Thanks Kamal Bin Mustafa. (#3)
  1778. - Prevent e.g. ``gmpy2-2.0.tar.gz`` from matching a request to
  1779. ``pip install gmpy``; sdist filename must begin with full project name
  1780. followed by a dash. Thanks casevh for the report. (#510)
  1781. - Allow package URLS to have querystrings. Thanks W. Trevor King. (#504)
  1782. - pip freeze now falls back to non-editable format rather than blowing up if it
  1783. can't determine the origin repository of an editable. Thanks Rory McCann.
  1784. (#58)
  1785. - Added a `__main__.py` file to enable `python -m pip` on Python versions
  1786. that support it. Thanks Alexey Luchko.
  1787. - Fixed upgrading from VCS url of project that does exist on index. Thanks
  1788. Andrew Knapp for the report. (#487)
  1789. - Fix upgrade from VCS url of project with no distribution on index.
  1790. Thanks Andrew Knapp for the report. (#486)
  1791. - Add a clearer error message on a malformed VCS url. Thanks Thomas Fenzl.
  1792. (#427)
  1793. - Added support for using any of the built in guaranteed algorithms in
  1794. ``hashlib`` as a checksum hash.
  1795. - Raise an exception if current working directory can't be found or accessed.
  1796. (#321)
  1797. - Removed special casing of the user directory and use the Python default
  1798. instead. (#82)
  1799. - Only warn about version conflicts if there is actually one. This re-enables
  1800. using ``==dev`` in requirements files. (#436)
  1801. - Moved tests to be run on Travis CI: https://travis-ci.org/pypa/pip
  1802. - Added a better help formatter.
  1803. 1.1 (2012-02-16)
  1804. ================
  1805. - Don't crash when a package's setup.py emits UTF-8 and then fails. Thanks
  1806. Marc Abramowitz. (#326)
  1807. - Added ``--target`` option for installing directly to arbitrary directory.
  1808. Thanks Stavros Korokithakis.
  1809. - Added support for authentication with Subversion repositories. Thanks
  1810. Qiangning Hong.
  1811. - ``--download`` now downloads dependencies as well. Thanks Qiangning Hong.
  1812. (#315)
  1813. - Errors from subprocesses will display the current working directory.
  1814. Thanks Antti Kaihola.
  1815. - Fixed compatibility with Subversion 1.7. Thanks Qiangning Hong. Note that
  1816. setuptools remains incompatible with Subversion 1.7; to get the benefits of
  1817. pip's support you must use Distribute rather than setuptools. (#369)
  1818. - Ignore py2app-generated macOS mpkg zip files in finder. Thanks Rene Dudfield.
  1819. (#57)
  1820. - Log to ~/Library/Logs/ by default on macOS framework installs. Thanks
  1821. Dan Callahan for report and patch. (#182)
  1822. - Understand version tags without minor version ("py3") in sdist filenames.
  1823. Thanks Stuart Andrews for report and Olivier Girardot for patch. (#310)
  1824. - pip now supports optionally installing setuptools "extras" dependencies; e.g.
  1825. "pip install Paste[openid]". Thanks Matt Maker and Olivier Girardot. (#7)
  1826. - freeze no longer borks on requirements files with --index-url or --find-links.
  1827. Thanks Herbert Pfennig. (#391)
  1828. - Handle symlinks properly. Thanks lebedov for the patch. (#288)
  1829. - pip install -U no longer reinstalls the same versions of packages. Thanks
  1830. iguananaut for the pull request. (#49)
  1831. - Removed ``-E``/``--environment`` option and ``PIP_RESPECT_VIRTUALENV``;
  1832. both use a restart-in-venv mechanism that's broken, and neither one is
  1833. useful since every virtualenv now has pip inside it. Replace ``pip -E
  1834. path/to/venv install Foo`` with ``virtualenv path/to/venv &&
  1835. path/to/venv/pip install Foo``.
  1836. - Fixed pip throwing an IndexError when it calls `scraped_rel_links`. (#366)
  1837. - pip search should set and return a useful shell status code. (#22)
  1838. - Added global ``--exists-action`` command line option to easier script file
  1839. exists conflicts, e.g. from editable requirements from VCS that have a
  1840. changed repo URL. (#351, #365)
  1841. 1.0.2 (2011-07-16)
  1842. ==================
  1843. - Fixed docs issues.
  1844. - Reinstall a package when using the ``install -I`` option. (#295)
  1845. - Finds a Git tag pointing to same commit as origin/master. (#283)
  1846. - Use absolute path for path to docs in setup.py. (#279)
  1847. - Correctly handle exceptions on Python3. (#314)
  1848. - Correctly parse ``--editable`` lines in requirements files. (#320)
  1849. 1.0.1 (2011-04-30)
  1850. ==================
  1851. - Start to use git-flow.
  1852. - `find_command` should not raise AttributeError. (#274)
  1853. - Respect Content-Disposition header. Thanks Bradley Ayers. (#273)
  1854. - pathext handling on Windows. (#233)
  1855. - svn+svn protocol. (#252)
  1856. - multiple CLI searches. (#44)
  1857. - Current working directory when running setup.py clean. (#266)
  1858. 1.0 (2011-04-04)
  1859. ================
  1860. - Added Python 3 support! Huge thanks to Vinay Sajip, Vitaly Babiy, Kelsey
  1861. Hightower, and Alex Gronholm, among others.
  1862. - Download progress only shown on a real TTY. Thanks Alex Morega.
  1863. - Fixed finding of VCS binaries to not be fooled by same-named directories.
  1864. Thanks Alex Morega.
  1865. - Fixed uninstall of packages from system Python for users of Debian/Ubuntu
  1866. python-setuptools package (workaround until fixed in Debian and Ubuntu).
  1867. - Added `get-pip.py <https://raw.github.com/pypa/pip/master/contrib/get-pip.py>`_
  1868. installer. Simply download and execute it, using the Python interpreter of
  1869. your choice::
  1870. $ curl -O https://raw.github.com/pypa/pip/master/contrib/get-pip.py
  1871. $ python get-pip.py
  1872. This may have to be run as root.
  1873. .. note::
  1874. Make sure you have `distribute <http://pypi.python.org/pypi/distribute>`_
  1875. installed before using the installer!
  1876. 0.8.3
  1877. =====
  1878. - Moved main repository to GitHub: https://github.com/pypa/pip
  1879. - Transferred primary maintenance from Ian to Jannis Leidel, Carl Meyer,
  1880. Brian Rosner
  1881. - Fixed no uninstall-on-upgrade with URL package. Thanks Oliver Tonnhofer.
  1882. (#14)
  1883. - Fixed egg name not properly resolving. Thanks Igor Sobreira. (#163)
  1884. - Fixed Non-alphabetical installation of requirements. Thanks Igor Sobreira.
  1885. (#178)
  1886. - Fixed documentation mentions --index instead of --index-url. Thanks
  1887. Kelsey Hightower (#199)
  1888. - rmtree undefined in mercurial.py. Thanks Kelsey Hightower. (#204)
  1889. - Fixed bug in Git vcs backend that would break during reinstallation.
  1890. - Fixed bug in Mercurial vcs backend related to pip freeze and branch/tag
  1891. resolution.
  1892. - Fixed bug in version string parsing related to the suffix "-dev".
  1893. 0.8.2
  1894. =====
  1895. - Avoid redundant unpacking of bundles (from pwaller)
  1896. - Fixed checking out the correct tag/branch/commit when updating an editable
  1897. Git requirement. (#32, #150, #161)
  1898. - Added ability to install version control requirements without making them
  1899. editable, e.g.::
  1900. pip install git+https://github.com/pypa/pip/
  1901. (#49)
  1902. - Correctly locate build and source directory on macOS. (#175)
  1903. - Added ``git+https://`` scheme to Git VCS backend.
  1904. 0.8.1
  1905. =====
  1906. - Added global --user flag as shortcut for --install-option="--user". From
  1907. Ronny Pfannschmidt.
  1908. - Added support for `PyPI mirrors <http://pypi.python.org/mirrors>`_ as
  1909. defined in `PEP 381 <https://www.python.org/dev/peps/pep-0381/>`_, from
  1910. Jannis Leidel.
  1911. - Fixed git revisions being ignored. Thanks John-Scott Atlakson. (#138)
  1912. - Fixed initial editable install of github package from a tag failing. Thanks
  1913. John-Scott Atlakson. (#95)
  1914. - Fixed installing if a directory in cwd has the same name as the package
  1915. you're installing. (#107)
  1916. - --install-option="--prefix=~/.local" ignored with -e. Thanks
  1917. Ronny Pfannschmidt and Wil Tan. (#39)
  1918. 0.8
  1919. ===
  1920. - Track which ``build/`` directories pip creates, never remove directories
  1921. it doesn't create. From Hugo Lopes Tavares.
  1922. - pip now accepts file:// index URLs. Thanks Dave Abrahams.
  1923. - Various cleanup to make test-running more consistent and less fragile.
  1924. Thanks Dave Abrahams.
  1925. - Real Windows support (with passing tests). Thanks Dave Abrahams.
  1926. - ``pip-2.7`` etc. scripts are created (Python-version specific scripts)
  1927. - ``contrib/build-standalone`` script creates a runnable ``.zip`` form of
  1928. pip, from Jannis Leidel
  1929. - Editable git repos are updated when reinstalled
  1930. - Fix problem with ``--editable`` when multiple ``.egg-info/`` directories
  1931. are found.
  1932. - A number of VCS-related fixes for ``pip freeze``, from Hugo Lopes Tavares.
  1933. - Significant test framework changes, from Hugo Lopes Tavares.
  1934. 0.7.2
  1935. =====
  1936. - Set zip_safe=False to avoid problems some people are encountering where
  1937. pip is installed as a zip file.
  1938. 0.7.1
  1939. =====
  1940. - Fixed opening of logfile with no directory name. Thanks Alexandre Conrad.
  1941. - Temporary files are consistently cleaned up, especially after
  1942. installing bundles, also from Alex Conrad.
  1943. - Tests now require at least ScriptTest 1.0.3.
  1944. 0.7
  1945. ===
  1946. - Fixed uninstallation on Windows
  1947. - Added ``pip search`` command.
  1948. - Tab-complete names of installed distributions for ``pip uninstall``.
  1949. - Support tab-completion when there is a global-option before the
  1950. subcommand.
  1951. - Install header files in standard (scheme-default) location when installing
  1952. outside a virtualenv. Install them to a slightly more consistent
  1953. non-standard location inside a virtualenv (since the standard location is
  1954. a non-writable symlink to the global location).
  1955. - pip now logs to a central location by default (instead of creating
  1956. ``pip-log.txt`` all over the place) and constantly overwrites the
  1957. file in question. On Unix and macOS this is ``'$HOME/.pip/pip.log'``
  1958. and on Windows it's ``'%HOME%\\pip\\pip.log'``. You are still able to
  1959. override this location with the ``$PIP_LOG_FILE`` environment variable.
  1960. For a complete (appended) logfile use the separate ``'--log'`` command line
  1961. option.
  1962. - Fixed an issue with Git that left an editable package as a checkout of a
  1963. remote branch, even if the default behaviour would have been fine, too.
  1964. - Fixed installing from a Git tag with older versions of Git.
  1965. - Expand "~" in logfile and download cache paths.
  1966. - Speed up installing from Mercurial repositories by cloning without
  1967. updating the working copy multiple times.
  1968. - Fixed installing directly from directories (e.g.
  1969. ``pip install path/to/dir/``).
  1970. - Fixed installing editable packages with ``svn+ssh`` URLs.
  1971. - Don't print unwanted debug information when running the freeze command.
  1972. - Create log file directory automatically. Thanks Alexandre Conrad.
  1973. - Make test suite easier to run successfully. Thanks Dave Abrahams.
  1974. - Fixed "pip install ." and "pip install .."; better error for directory
  1975. without setup.py. Thanks Alexandre Conrad.
  1976. - Support Debian/Ubuntu "dist-packages" in zip command. Thanks duckx.
  1977. - Fix relative --src folder. Thanks Simon Cross.
  1978. - Handle missing VCS with an error message. Thanks Alexandre Conrad.
  1979. - Added --no-download option to install; pairs with --no-install to separate
  1980. download and installation into two steps. Thanks Simon Cross.
  1981. - Fix uninstalling from requirements file containing -f, -i, or
  1982. --extra-index-url.
  1983. - Leftover build directories are now removed. Thanks Alexandre Conrad.
  1984. 0.6.3
  1985. =====
  1986. - Fixed import error on Windows with regard to the backwards compatibility
  1987. package
  1988. 0.6.2
  1989. =====
  1990. - Fixed uninstall when /tmp is on a different filesystem.
  1991. - Fixed uninstallation of distributions with namespace packages.
  1992. 0.6.1
  1993. =====
  1994. - Added support for the ``https`` and ``http-static`` schemes to the
  1995. Mercurial and ``ftp`` scheme to the Bazaar backend.
  1996. - Fixed uninstallation of scripts installed with easy_install.
  1997. - Fixed an issue in the package finder that could result in an
  1998. infinite loop while looking for links.
  1999. - Fixed issue with ``pip bundle`` and local files (which weren't being
  2000. copied into the bundle), from Whit Morriss.
  2001. 0.6
  2002. ===
  2003. - Add ``pip uninstall`` and uninstall-before upgrade (from Carl Meyer).
  2004. - Extended configurability with config files and environment variables.
  2005. - Allow packages to be upgraded, e.g., ``pip install Package==0.1``
  2006. then ``pip install Package==0.2``.
  2007. - Allow installing/upgrading to Package==dev (fix "Source version does not
  2008. match target version" errors).
  2009. - Added command and option completion for bash and zsh.
  2010. - Extended integration with virtualenv by providing an option to
  2011. automatically use an active virtualenv and an option to warn if no active
  2012. virtualenv is found.
  2013. - Fixed a bug with pip install --download and editable packages, where
  2014. directories were being set with 0000 permissions, now defaults to 755.
  2015. - Fixed uninstallation of easy_installed console_scripts.
  2016. - Fixed uninstallation on macOS Framework layout installs
  2017. - Fixed bug preventing uninstall of editables with source outside venv.
  2018. - Creates download cache directory if not existing.
  2019. 0.5.1
  2020. =====
  2021. - Fixed a couple little bugs, with git and with extensions.
  2022. 0.5
  2023. ===
  2024. - Added ability to override the default log file name (``pip-log.txt``)
  2025. with the environmental variable ``$PIP_LOG_FILE``.
  2026. - Made the freeze command print installed packages to stdout instead of
  2027. writing them to a file. Use simple redirection (e.g.
  2028. ``pip freeze > stable-req.txt``) to get a file with requirements.
  2029. - Fixed problem with freezing editable packages from a Git repository.
  2030. - Added support for base URLs using ``<base href='...'>`` when parsing
  2031. HTML pages.
  2032. - Fixed installing of non-editable packages from version control systems.
  2033. - Fixed issue with Bazaar's bzr+ssh scheme.
  2034. - Added --download-dir option to the install command to retrieve package
  2035. archives. If given an editable package it will create an archive of it.
  2036. - Added ability to pass local file and directory paths to ``--find-links``,
  2037. e.g. ``--find-links=file:///path/to/my/private/archive``
  2038. - Reduced the amount of console log messages when fetching a page to find a
  2039. distribution was problematic. The full messages can be found in pip-log.txt.
  2040. - Added ``--no-deps`` option to install ignore package dependencies
  2041. - Added ``--no-index`` option to ignore the package index (PyPI) temporarily
  2042. - Fixed installing editable packages from Git branches.
  2043. - Fixes freezing of editable packages from Mercurial repositories.
  2044. - Fixed handling read-only attributes of build files, e.g. of Subversion and
  2045. Bazaar on Windows.
  2046. - When downloading a file from a redirect, use the redirected
  2047. location's extension to guess the compression (happens specifically
  2048. when redirecting to a bitbucket.org tip.gz file).
  2049. - Editable freeze URLs now always use revision hash/id rather than tip or
  2050. branch names which could move.
  2051. - Fixed comparison of repo URLs so incidental differences such as
  2052. presence/absence of final slashes or quoted/unquoted special
  2053. characters don't trigger "ignore/switch/wipe/backup" choice.
  2054. - Fixed handling of attempt to checkout editable install to a
  2055. non-empty, non-repo directory.
  2056. 0.4
  2057. ===
  2058. - Make ``-e`` work better with local hg repositories
  2059. - Construct PyPI URLs the exact way easy_install constructs URLs (you
  2060. might notice this if you use a custom index that is
  2061. slash-sensitive).
  2062. - Improvements on Windows (from `Ionel Maries Cristian
  2063. <https://ionelmc.wordpress.com/>`_).
  2064. - Fixed problem with not being able to install private git repositories.
  2065. - Make ``pip zip`` zip all its arguments, not just the first.
  2066. - Fix some filename issues on Windows.
  2067. - Allow the ``-i`` and ``--extra-index-url`` options in requirements
  2068. files.
  2069. - Fix the way bundle components are unpacked and moved around, to make
  2070. bundles work.
  2071. - Adds ``-s`` option to allow the access to the global site-packages if a
  2072. virtualenv is to be created.
  2073. - Fixed support for Subversion 1.6.
  2074. 0.3.1
  2075. =====
  2076. - Improved virtualenv restart and various path/cleanup problems on win32.
  2077. - Fixed a regression with installing from svn repositories (when not
  2078. using ``-e``).
  2079. - Fixes when installing editable packages that put their source in a
  2080. subdirectory (like ``src/``).
  2081. - Improve ``pip -h``
  2082. 0.3
  2083. ===
  2084. - Added support for editable packages created from Git, Mercurial and Bazaar
  2085. repositories and ability to freeze them. Refactored support for version
  2086. control systems.
  2087. - Do not use ``sys.exit()`` from inside the code, instead use a
  2088. return. This will make it easier to invoke programmatically.
  2089. - Put the install record in ``Package.egg-info/installed-files.txt``
  2090. (previously they went in
  2091. ``site-packages/install-record-Package.txt``).
  2092. - Fix a problem with ``pip freeze`` not including ``-e svn+`` when an
  2093. svn structure is peculiar.
  2094. - Allow ``pip -E`` to work with a virtualenv that uses a different
  2095. version of Python than the parent environment.
  2096. - Fixed Win32 virtualenv (``-E``) option.
  2097. - Search the links passed in with ``-f`` for packages.
  2098. - Detect zip files, even when the file doesn't have a ``.zip``
  2099. extension and it is served with the wrong Content-Type.
  2100. - Installing editable from existing source now works, like ``pip
  2101. install -e some/path/`` will install the package in ``some/path/``.
  2102. Most importantly, anything that package requires will also be
  2103. installed by pip.
  2104. - Add a ``--path`` option to ``pip un/zip``, so you can avoid zipping
  2105. files that are outside of where you expect.
  2106. - Add ``--simulate`` option to ``pip zip``.
  2107. 0.2.1
  2108. =====
  2109. - Fixed small problem that prevented using ``pip.py`` without actually
  2110. installing pip.
  2111. - Fixed ``--upgrade``, which would download and appear to install
  2112. upgraded packages, but actually just reinstall the existing package.
  2113. - Fixed Windows problem with putting the install record in the right
  2114. place, and generating the ``pip`` script with Setuptools.
  2115. - Download links that include embedded spaces or other unsafe
  2116. characters (those characters get %-encoded).
  2117. - Fixed use of URLs in requirement files, and problems with some blank
  2118. lines.
  2119. - Turn some tar file errors into warnings.
  2120. 0.2
  2121. ===
  2122. - Renamed to ``pip``, and to install you now do ``pip install
  2123. PACKAGE``
  2124. - Added command ``pip zip PACKAGE`` and ``pip unzip PACKAGE``. This
  2125. is particularly intended for Google App Engine to manage libraries
  2126. to stay under the 1000-file limit.
  2127. - Some fixes to bundles, especially editable packages and when
  2128. creating a bundle using unnamed packages (like just an svn
  2129. repository without ``#egg=Package``).
  2130. 0.1.4
  2131. =====
  2132. - Added an option ``--install-option`` to pass options to pass
  2133. arguments to ``setup.py install``
  2134. - ``.svn/`` directories are no longer included in bundles, as these
  2135. directories are specific to a version of svn -- if you build a
  2136. bundle on a system with svn 1.5, you can't use the checkout on a
  2137. system with svn 1.4. Instead a file ``svn-checkout.txt`` is
  2138. included that notes the original location and revision, and the
  2139. command you can use to turn it back into an svn checkout. (Probably
  2140. unpacking the bundle should, maybe optionally, recreate this
  2141. information -- but that is not currently implemented, and it would
  2142. require network access.)
  2143. - Avoid ambiguities over project name case, where for instance
  2144. MyPackage and mypackage would be considered different packages.
  2145. This in particular caused problems on Macs, where ``MyPackage/`` and
  2146. ``mypackage/`` are the same directory.
  2147. - Added support for an environmental variable
  2148. ``$PIP_DOWNLOAD_CACHE`` which will cache package downloads, so
  2149. future installations won't require large downloads. Network access
  2150. is still required, but just some downloads will be avoided when
  2151. using this.
  2152. 0.1.3
  2153. =====
  2154. - Always use ``svn checkout`` (not ``export``) so that
  2155. ``tag_svn_revision`` settings give the revision of the package.
  2156. - Don't update checkouts that came from ``.pybundle`` files.
  2157. 0.1.2
  2158. =====
  2159. - Improve error text when there are errors fetching HTML pages when
  2160. seeking packages.
  2161. - Improve bundles: include empty directories, make them work with
  2162. editable packages.
  2163. - If you use ``-E env`` and the environment ``env/`` doesn't exist, a
  2164. new virtual environment will be created.
  2165. - Fix ``dependency_links`` for finding packages.
  2166. 0.1.1
  2167. =====
  2168. - Fixed a NameError exception when running pip outside of a virtualenv
  2169. environment.
  2170. - Added HTTP proxy support (from Prabhu Ramachandran)
  2171. - Fixed use of ``hashlib.md5`` on python2.5+ (also from Prabhu Ramachandran)
  2172. 0.1
  2173. ===
  2174. - Initial release